/*****************************************************************/
/*                      World of GreyHawk                        */
/*      Begun in 1998, originally based on Circle3.0 and others  */
/* File:                                                         */
/* Purpose:                                                      */
/*****************************************************************/

#include "conf.h"
#include "sysdep.h"

#include "structs.h"

#include "utils.h"
#include "comm.h"
#include "interpreter.h"
#include "handler.h"
#include "db.h"
#include "boards.h"
#include "chatlink.h"
#include "dg_scripts.h"
#include "map.h"

/* extern variables */
extern struct room_data *world;
extern struct descriptor_data *descriptor_list;
extern struct char_data *character_list;
extern struct zone_data *zone_table;
extern struct index_data *obj_index;
extern char *language_known(struct char_data *ch, struct char_data *vict);
extern char *language_crypt(struct char_data *ch, struct char_data *victim, char *message);
extern byte ProximityCheck(struct char_data *ch, struct obj_data *obj, struct char_data *target, int door);
extern ACMD(do_echo);
extern byte victWithinRangeofLoc(struct location_data *loc, struct char_data *vict, int distance);
struct index_data *mob_index;
extern void search_replace(char *string, const char *find, const char *replace);

ACMD(do_say)
{
  struct char_data *target;
  int i, dir, room, distance = 5, remaining, face = 0, state = 0, justice = FALSE;
  struct location_data *loc = NULL;
  char speech_string[MAX_STRING_LENGTH], speech_string2[MAX_STRING_LENGTH];

  skip_spaces(&argument);

  for (i = 0; *(argument + i) == ' '; i++);

  if (!*(argument + i))
    send_to_char("Say what?\r\n", ch);
  else {
    if (IS_AFFECTED4(ch, AFF4_SLNT_MOVE))
      REMOVE_BIT(AFF4_FLAGS(ch), AFF4_SLNT_MOVE);

    if (strstr(argument, ":)") != NULL)
      face = 1;
    else if (strstr(argument, ";)") != NULL)
      face = 2;
    else if (strstr(argument, ";(") != NULL)
      face = 3;
    else if (strstr(argument, ":(") != NULL)
      face = 4;
    else if ((strstr(argument, "=P") != NULL) ||
	     (strstr(argument, ":P") != NULL))
      face = 5;

    search_replace(argument, " :)", "");
    search_replace(argument, " ;)", "");
    search_replace(argument, " ;(", "");
    search_replace(argument, " :(", "");
    search_replace(argument, ":)", "");
    search_replace(argument, ";)", "");
    search_replace(argument, ";(", "");
    search_replace(argument, ":(", "");
    search_replace(argument, "=P", "");
    search_replace(argument, ":P", "");

    if (argument[strlen(argument) - 1] != '.' && argument[strlen(argument) - 1] != '?'
	&& argument[strlen(argument) - 1] != '!')
      strcat(argument, ".");


    if (subcmd == SCMD_SHOUT)
      state = 3;
    else if (argument[strlen(argument) - 1] == '?')
      state = 2;
    else if (argument[strlen(argument) - 1] == '!') {
      if (argument[strlen(argument) - 2] == '*')
	state = 4;
      else if (argument[strlen(argument) - 2] == '&')
	state = 5;
      else
	state = 1;
    } else
      state = 0;

    search_replace(argument, "*!", ".");
    search_replace(argument, "&!", ".");

    speech_string[0] = '\0';
    speech_string2[0] = '\0';

    switch (face) {
    case 0:
      break;			/* No emoticon used */
    case 1:
      sprintf(speech_string + strlen(speech_string), "smiles and ");
      sprintf(speech_string2 + strlen(speech_string2), "smile and ");
      break;
    case 2:
      sprintf(speech_string + strlen(speech_string), "winks and ");
      sprintf(speech_string2 + strlen(speech_string2), "wink and ");
      break;
    case 3:
      sprintf(speech_string + strlen(speech_string), "scowls and ");
      sprintf(speech_string2 + strlen(speech_string2), "scowls and ");
      break;
    case 4:
      sprintf(speech_string + strlen(speech_string), "frowns and ");
      sprintf(speech_string2 + strlen(speech_string2), "frown and ");
      break;
    case 5:
      sprintf(speech_string + strlen(speech_string), "perversly smiles and ");
      sprintf(speech_string2 + strlen(speech_string2), "perversly smile and ");
      break;
    default:
      break;
    }

    switch (state) {
    case 0:
      sprintf(speech_string + strlen(speech_string), "says");
      sprintf(speech_string2 + strlen(speech_string2), "say");
      break;
    case 1:
      sprintf(speech_string + strlen(speech_string), "exclaims");
      sprintf(speech_string2 + strlen(speech_string2), "exclaim");
      break;
    case 2:
      sprintf(speech_string + strlen(speech_string), "asks");
      sprintf(speech_string2 + strlen(speech_string2), "ask");
      break;
    case 3:
      sprintf(speech_string + strlen(speech_string), "shouts");
      sprintf(speech_string2 + strlen(speech_string2), "shout");
      break;
    case 4:
      sprintf(speech_string + strlen(speech_string), "grunts");
      sprintf(speech_string2 + strlen(speech_string2), "grunt");
      break;
    case 5:
      sprintf(speech_string + strlen(speech_string), "sneers");
      sprintf(speech_string2 + strlen(speech_string2), "sneer");
      break;
    default:
      break;
    }

    if (PRF_FLAGGED(ch, PRF_NOREPEAT))
      send_to_char(OK, ch);
    else {
      sprintf(buf, "You %s, '%s'", speech_string2, argument);
      act(buf, FALSE, ch, 0, argument, TO_CHAR);
    }
    CREATE(loc, struct location_data, 1);
    /* distance is based on type, whisper, say, shout */
    if (subcmd == SCMD_SAY)
      distance = 10;
    else if (subcmd == SCMD_SHOUT)
      distance = 50;
    room = ch->in_room;
    remaining = distance;
    for (dir = -1; dir < NUM_OF_DIRS; dir++) {
      if (dir > -1 && (
			!world[ch->in_room].dir_option[dir] ||
			DRAW_WALL_ONLY(ch->in_room, dir) ||
			world[ch->in_room].dir_option[dir]->to_room < 1 ||
			room == ch->in_room ||	/* looped rooms */
      IS_SET(world[ch->in_room].dir_option[dir]->exit_info, EX_ISDOOR) ||
	     IS_SET(VIRTUAL_EXIT(ch->in_room, dir)->exit_info, EX_CLOSED)
	  ))
	continue;
      if (dir == -1)
	room = ch->in_room;
      else
	room = world[ch->in_room].dir_option[dir]->to_room;

      switch (dir) {
      case -1:
	remaining = distance;
	loc->real_room = room;
	loc->x_cord = GET_X_CORD(ch);
	loc->y_cord = GET_Y_CORD(ch);
	loc->z_cord = GET_Z_CORD(ch);
	break;
      case NORTH:
	remaining = distance - GET_X_CORD(ch);
	loc->real_room = room;
	loc->x_cord = GET_X_SIZE(room) - 1;
	loc->y_cord = GET_Y_CORD(ch);
	loc->z_cord = GET_Z_CORD(ch);
	break;
      case EAST:
	remaining = distance - GET_Y_SIZE(room) - 1 - GET_Y_CORD(ch);
	loc->real_room = room;
	loc->x_cord = GET_X_CORD(ch);
	loc->y_cord = 0;
	loc->z_cord = GET_Z_CORD(ch);
	break;
      case SOUTH:
	remaining = distance - GET_X_SIZE(room) - 1 - GET_X_CORD(ch);
	loc->real_room = room;
	loc->x_cord = 0;
	loc->y_cord = GET_Y_CORD(ch);
	loc->z_cord = GET_Z_CORD(ch);
	break;
      case WEST:
	remaining = distance - GET_Y_CORD(ch);
	loc->real_room = room;
	loc->x_cord = GET_X_SIZE(room) - 1;
	loc->y_cord = GET_Y_CORD(ch);
	loc->z_cord = GET_Z_CORD(ch);
	break;
      }

      if (argument[0] == '*' && argument[1] == 'G') {
	search_replace(argument, "*", "");
	if (zone_table[world[room].zone].kingdom)
	  justice = TRUE;
      }
      for (target = world[room].people; target; target = target->next_in_room) {
	if (target != ch && victWithinRangeofLoc(loc, target, remaining) && !IS_AFFECTED4(target, AFF4_DEAF)) {
	  sprintf(buf, "$n %s %s'%s'", speech_string, language_known(ch, target),
		  language_crypt(ch, target, argument + i));
	  act(buf, FALSE, ch, 0, target, TO_VICT | DG_NO_TRIG);
	}
	if (justice && IS_GUARD(target)) {
	  sprintf(buf2, "shout I hear you asshole, but I'm busy, so shut up!\r\n");
	  command_interpreter(target, buf2);
	}
      }
    }
    FREE(loc);
#ifdef ELIZA
    chatperformtoroom(ch, argument);
#endif
  }

  /* trigger check */
  speech_mtrigger(ch, argument);
  speech_wtrigger(ch, argument);
  speech_otrigger(ch, argument);
}


ACMD(do_gsay)
{
  struct char_data *k;
  struct group_type *f;

  skip_spaces(&argument);

  if (!IS_AFFECTED(ch, AFF_GROUP)) {
    send_to_char("But you are not the member of a group!\r\n", ch);
    return;
  }
  if (!*argument)
    send_to_char("Yes, but WHAT do you want to group-say?\r\n", ch);
  else {
    if (ch->leader)
      k = ch->leader;
    else
      k = ch;

    sprintf(buf, "&+G$n group-says, '%s'&n", argument);

    if (IS_AFFECTED(k, AFF_GROUP) && (k != ch))
      act(buf, FALSE, ch, 0, k, TO_VICT | TO_SLEEP);

    for (f = k->group; f; f = f->next)
      if (IS_AFFECTED(f->follower, AFF_GROUP) && (f->follower != ch))
	act(buf, FALSE, ch, 0, f->follower, TO_VICT | TO_SLEEP);

    if (PRF_FLAGGED(ch, PRF_NOREPEAT))
      send_to_char(OK, ch);
    else {
      sprintf(buf, "&+GYou group-say, '%s'&n", argument);
      act(buf, FALSE, ch, 0, 0, TO_CHAR | TO_SLEEP);
    }
  }
}


void perform_tell(struct char_data *ch, struct char_data *vict, char *argu, byte ptell)
{

  if (!ptell) {
    sprintf(buf, "&+W$n tells you, '%s'&n", argu);
    act(buf, FALSE, ch, 0, vict, TO_VICT | TO_SLEEP);

    if (IS_TRUSTED(vict) && !IS_TRUSTED(ch))
      send_to_char("Reminder: Use petition for general questions of the creators, not tell.\r\n", ch);
    if (PRF_FLAGGED(ch, PRF_NOREPEAT))
      send_to_char(OK, ch);
    else {
      sprintf(buf, "&+WYou tell $N, '%s'&n", argu);
      act(buf, FALSE, ch, 0, vict, TO_CHAR | TO_SLEEP);
    }
  } else {
    sprintf(buf, "&+R$n responds to $N: '%s'&n", argu);
    act(buf, FALSE, ch, 0, vict, TO_VICT | TO_SLEEP);
    act(buf, FALSE, ch, 0, vict, TO_GODS);

    if (PRF_FLAGGED(ch, PRF_NOREPEAT))
      send_to_char(OK, ch);
  }
  GET_LAST_TELL(vict) = GET_IDNUM(ch);
#ifdef ELIZA
  chatperform(vict, ch, argu);
#endif
}

/*
 * Yes, do_tell probably could be combined with whisper and ask, but
 * called frequently, and should IMHO be kept as tight as possible.
 */
ACMD(do_tell)
{
  struct char_data *vict;
  char buf3[MAX_STRING_LENGTH];

  half_chop(argument, buf, buf2);

  if (!*buf || !*buf2)
    send_to_char("Who do you wish to tell what??\r\n", ch);
  else if (!(vict = get_char_vis(ch, buf))) {
/*    send_to_char(NOPERSON, ch); */
    CAP(buf);
    sprintf(buf3, "%s can't hear you.\r\n", buf);
    send_to_char(buf3, ch);
  } else if (ch == vict)
    send_to_char("You try to tell yourself something.\r\n", ch);
  else if (PRF_FLAGGED(ch, PRF_NOTELL))
    send_to_char("You can't tell other people while you have notell on.\r\n", ch);
  else if (ROOM_FLAGGED(ch->in_room, ROOM_SOUNDPROOF))
    send_to_char("The walls seem to absorb your words.\r\n", ch);
  else if (!IS_NPC(vict) && !vict->desc)	/* linkless */
    act("$E's linkless at the moment.", FALSE, ch, 0, vict, TO_CHAR | TO_SLEEP);
  else if (PLR_FLAGGED(vict, PLR_WRITING))
    act("$E's writing a message right now; try again later.",
	FALSE, ch, 0, vict, TO_CHAR | TO_SLEEP);
  else if (PRF_FLAGGED(vict, PRF_NOTELL) || ROOM_FLAGGED(vict->in_room, ROOM_SOUNDPROOF))
    act("$E can't hear you.", FALSE, ch, 0, vict, TO_CHAR | TO_SLEEP);
  else if (subcmd == SCMD_PTELL)
    perform_tell(ch, vict, buf2, TRUE);
  else
    perform_tell(ch, vict, buf2, FALSE);
}


ACMD(do_reply)
{
  struct char_data *tch = character_list;

  skip_spaces(&argument);

  if (GET_LAST_TELL(ch) == NOBODY)
    send_to_char("You have no-one to reply to!\r\n", ch);
  else if (!*argument)
    send_to_char("What is your reply?\r\n", ch);
  else {
    /*
     * Make sure the person you're replying to is still playing by searching
     * for them.  Note, now last tell is stored as player IDnum instead of
     * a pointer, which is much better because it's safer, plus will still
     * work if someone logs out and back in again.
     */

    while (tch != NULL && GET_IDNUM(tch) != GET_LAST_TELL(ch))
      tch = tch->next;

    if (tch == NULL)
      send_to_char("They are no longer playing.\r\n", ch);
    else
      perform_tell(ch, tch, argument, FALSE);
  }
}


ACMD(do_spec_comm)
{
  struct char_data *vict;
  char *action_sing, *action_plur, *action_others;

  if (subcmd == SCMD_WHISPER) {
    action_sing = "whisper to";
    action_plur = "whispers to";
    action_others = "$n whispers something to $N.";
  } else {
    action_sing = "ask";
    action_plur = "asks";
    action_others = "$n asks $N a question.";
  }

  half_chop(argument, buf, buf2);

  if (!*buf || !*buf2) {
    sprintf(buf, "Whom do you want to %s.. and what??\r\n", action_sing);
    send_to_char(buf, ch);
  } else if (!(vict = get_char_room_vis(ch, buf)))
    send_to_char(NOPERSON, ch);
  else if (vict == ch)
    send_to_char("You can't get your mouth close enough to your ear...\r\n", ch);
  else {
    if (!IS_AFFECTED4(vict, AFF4_DEAF))
      sprintf(buf, "$n %s you, '%s'", action_plur, buf2);
    else
      sprintf(buf, "$n %s you something, but you can't hear $m.", action_plur);
    act(buf, FALSE, ch, 0, vict, TO_VICT);
    if (PRF_FLAGGED(ch, PRF_NOREPEAT))
      send_to_char(OK, ch);
    else {
      sprintf(buf, "You %s %s, '%s'\r\n", action_sing, GET_NAME(vict), buf2);
      act(buf, FALSE, ch, 0, 0, TO_CHAR);
    }
    act(action_others, FALSE, ch, 0, vict, TO_NOTVICT);
  }
}



#define MAX_NOTE_LENGTH 1000	/* arbitrary */

ACMD(do_write)
{
  struct obj_data *paper = 0, *pen = 0, *obj;
  char *papername, *penname;
  int found = 0;

  /* before we do anything, lets see if there's a board involved. */
  for (obj = ch->carrying; obj; obj = obj->next_content) {
    if (GET_OBJ_TYPE(obj) == ITEM_BOARD) {
      found = 1;
      break;
    }
  }
  if (!obj) {
    for (obj = world[ch->in_room].contents; obj; obj = obj->next_content) {
      if (GET_OBJ_TYPE(obj) == ITEM_BOARD && ProximityCheck(ch, obj, NULL, -1)) {
	found = 1;
	break;
      } else if (GET_OBJ_TYPE(obj) == ITEM_BOARD)
	found = 2;
    }
  }
  if (found == 2) {
    send_to_char("That is much too far away to write on.\r\n", ch);
    return;
  }
  if (obj && found) {		/* then there IS a board! */
    Board_write_message(GET_OBJ_VNUM(obj), ch, argument);
  } else {
    papername = buf1;
    penname = buf2;

    two_arguments(argument, papername, penname);

    if (!ch->desc)
      return;

    if (!*papername) {		/* nothing was delivered */
      send_to_char("Write?  With what?  ON what?  What are you trying to do?!?\r\n", ch);
      return;
    }
    if (*penname) {		/* there were two arguments */
      if (!(paper = get_obj_in_list_vis(ch, papername, ch->carrying))) {
	sprintf(buf, "You have no %s.\r\n", papername);
	send_to_char(buf, ch);
	return;
      }
      if (!(pen = get_obj_in_list_vis(ch, penname, ch->carrying))) {
	sprintf(buf, "You have no %s.\r\n", penname);
	send_to_char(buf, ch);
	return;
      }
    } else {			/* there was one arg.. let's see what we can find */
      if (!(paper = get_obj_in_list_vis(ch, papername, ch->carrying))) {
	sprintf(buf, "There is no %s in your inventory.\r\n", papername);
	send_to_char(buf, ch);
	return;
      }
      if (GET_OBJ_TYPE(paper) == ITEM_PEN) {	/* oops, a pen.. */
	pen = paper;
	paper = 0;
      } else if (GET_OBJ_TYPE(paper) != ITEM_NOTE) {
	send_to_char("That thing has nothing to do with writing.\r\n", ch);
	return;
      }
      /* One object was found.. now for the other one. */
      if (!GET_EQ(ch, WEAR_HOLD)) {
	sprintf(buf, "You can't write with %s %s alone.\r\n", AN(papername),
		papername);
	send_to_char(buf, ch);
	return;
      }
      if (!CAN_SEE_OBJ(ch, GET_EQ(ch, WEAR_HOLD))) {
	send_to_char("The stuff in your hand is invisible!  Yeech!!\r\n", ch);
	return;
      }
      if (pen)
	paper = GET_EQ(ch, WEAR_HOLD);
      else
	pen = GET_EQ(ch, WEAR_HOLD);

    }


    /* ok.. now let's see what kind of stuff we've found */
    if (GET_OBJ_TYPE(pen) != ITEM_PEN)
      act("$p is no good for writing with.", FALSE, ch, pen, 0, TO_CHAR);
    else if (GET_OBJ_TYPE(paper) != ITEM_NOTE)
      act("You can't write on $p.", FALSE, ch, paper, 0, TO_CHAR);
    else if (paper->action_description)
      send_to_char("There's something written on it already.\r\n", ch);
    else {
      /* we can write - hooray! */
      /* this is the PERFECT code example of how to set up:
       * a) the text editor with a message already loaed
       * b) the abort buffer if the player aborts the message
       */
      ch->desc->backstr = NULL;
      send_to_char("Write your note.  (/s saves /h for help)\r\n", ch);
      /* ok, here we check for a message ALREADY on the paper */
      if (paper->action_description) {
	/* we str_dup the original text to the descriptors->backstr */
	ch->desc->backstr = str_dup(paper->action_description);
	/* send to the player what was on the paper (cause this is already */
	/* loaded into the editor) */
	send_to_char(paper->action_description, ch);
      }
      act("$n begins to jot down a note.", TRUE, ch, 0, 0, TO_PROXIMITY);
      /* assign the descriptor's->str the value of the pointer to the text */
      /* pointer so that we can reallocate as needed (hopefully that made */
      /* sense :>) */
#ifndef MUDFTP
      ch->desc->str = &paper->action_description;
      ch->desc->max_str = MAX_NOTE_LENGTH;
#else
      string_write(ch->desc, &paper->action_description, MAX_NOTE_LENGTH, 0, NULL);
#endif

    }
  }
}



ACMD(do_page)
{
  struct descriptor_data *d;
  struct char_data *vict;

  half_chop(argument, arg, buf2);

  if (IS_NPC(ch))
    send_to_char("Monsters can't page.. go away.\r\n", ch);
  else if (!*arg)
    send_to_char("Whom do you wish to page?\r\n", ch);
  else {
    sprintf(buf, "\007\007*%s* %s\r\n", GET_NAME(ch), buf2);
    if (!str_cmp(arg, "all")) {
      if (IS_TRUSTED(ch)) {
	for (d = descriptor_list; d; d = d->next)
	  if (!d->connected && d->character)
	    act(buf, FALSE, ch, 0, d->character, TO_VICT);
      } else
	send_to_char("You will never be godly enough to do that!\r\n", ch);
      return;
    }
    if ((vict = get_char_vis(ch, arg)) != NULL) {
      act(buf, FALSE, ch, 0, vict, TO_VICT);
      if (PRF_FLAGGED(ch, PRF_NOREPEAT))
	send_to_char(OK, ch);
      else
	act(buf, FALSE, ch, 0, vict, TO_CHAR);
      return;
    } else
      send_to_char("There is no such person in the game!\r\n", ch);
  }
}


/**********************************************************************
 * generalized communication func, originally by Fred C. Merkel (Torg) *
  *********************************************************************/

ACMD(do_gen_comm)
{
  struct descriptor_data *i;

  /* Array of flags which must _not_ be set in order for comm to be heard */
  static int channels[] =
  {
    0,
    PRF_DEAF,
    0,
    0
  };

  /*
   * com_msgs: [0] Message if you can't perform the action because of noshout
   *           [1] color if needed
   *           [2] name of the action
   *           [3] message if you're not on the channel
   */
  static char *com_msgs[][4] =
  {
    {"You cannot petition!!\r\n",
     "&+R",
     "petition",
     "Sorry, you are blocked from whining to the gods.\r\n"},
  };

  if (PLR_FLAGGED(ch, PLR_NOSHOUT)) {
    send_to_char(com_msgs[subcmd][0], ch);
    return;
  }
  if (ROOM_FLAGGED(ch->in_room, ROOM_SOUNDPROOF)) {
    send_to_char("The walls seem to absorb your words.\r\n", ch);
    return;
  }
  /* make sure the char is on the channel */
  if (PRF_FLAGGED(ch, channels[subcmd])) {
    send_to_char(com_msgs[subcmd][3], ch);
    return;
  }
  /* skip leading spaces */
  skip_spaces(&argument);

  /* make sure that there is something there to say! */
  if (!*argument) {
    sprintf(buf1, "Yes, %s, fine, %s we must, but WHAT???\r\n",
	    com_msgs[subcmd][2], com_msgs[subcmd][2]);
    send_to_char(buf1, ch);
    return;
  }
  /* first, set up strings to be given to the communicator */
  if (PRF_FLAGGED(ch, PRF_NOREPEAT))
    send_to_char(OK, ch);
  else {
    sprintf(buf1, "You %s, '%s'", com_msgs[subcmd][2], argument);
    act(buf1, FALSE, ch, 0, 0, TO_CHAR | TO_SLEEP);
  }

  sprintf(buf, "%s$n %ss, '%s'&n", com_msgs[subcmd][1], com_msgs[subcmd][2], argument);

  /* now send all the strings out */
  if (subcmd == SCMD_PETITION) {
    act(buf, FALSE, ch, 0, ch, TO_GODS);
    return;
  }
  for (i = descriptor_list; i; i = i->next) {
    if (!i->connected && i->character && i->character != ch &&
	(!PRF_FLAGGED(i->character, channels[subcmd]) || IS_NPC(i->character)) &&
     (!PLR_FLAGGED(i->character, PLR_WRITING) || IS_NPC(i->character)) &&
	!ROOM_FLAGGED(i->character->in_room, ROOM_SOUNDPROOF)) {

      act(buf, FALSE, ch, 0, i->character, TO_VICT | TO_SLEEP);
    }
  }
}

#ifdef ELIZA
void chatperform(struct char_data *ch, struct char_data *victim, char *msg)
{
  char *reply, *s, *t;

  if (!IS_NPC(ch) || (victim != NULL && IS_NPC(victim)))
    return;			/* ignores ch who are PCs and victims who are NPCs */

  sprintf(buf, "%d", GET_MOB_VNUM(ch));
  reply = dochat(buf, msg, victim ? GET_NAME(victim) : "you");

  if (reply) {
    switch (reply[0]) {
    case '\0':			/* null msg */
      break;
    case '"':			/* do say */
      do_say(ch, reply + 1, 0, 0);
      break;
    case ':':			/* do emote */
      do_echo(ch, reply + 1, 0, SCMD_EMOTE);
      break;
    case '!':			/* execute command thru interpreter */
      s = reply + 1;

      /* RK: changed to perform a list of commands seperated by ';' */

      while (*s != '\0') {
	t = strchr(s, ';');

	if (t == NULL) {
	  command_interpreter(ch, s);
	  break;
	} else {
	  *t = '\0';
	  command_interpreter(ch, s);
	  s = t + 1;
	}
      }
      break;
    default:			/* is a say or tell */
/*      if (victim == NULL) */
      do_say(ch, reply, 0, 0);
/*
   else {
   char buf[MAX_STRING_LENGTH];
   sprintf(buf, "$N tells you, '%s'", reply);
   act(buf, FALSE, victim, NULL, ch, TO_CHAR);
   GET_LAST_TELL(victim) = GET_IDNUM(ch);
   }
 */
    }
  }
}

/* ch here is the PC saying the phrase
 */
void chatperformtoroom(struct char_data *ch, char *txt)
{
  struct char_data *vch, *next_ch;
  return;			/* off for now */
/*
   if (IS_NPC(ch))
   return;
 */
  for (vch = world[ch->in_room].people; vch != NULL; vch = next_ch) {
    next_ch = vch->next_in_room;
    if (IS_NPC(vch) && AWAKE(vch) && number(0, 1)) {
      chatperform(vch, ch, txt);
      return;			/* only one reply right now. Need some logic here... */
    }
  }
}
#endif
