/*****************************************************************/
/*                      World of GreyHawk                        */
/*      Begun in 1998, originally based on Circle3.0 and others  */
/* File:                                                         */
/* Purpose:                                                      */
/*****************************************************************/

#define PWIPE
/* rather than doing these over and over again, define once here and use the
   defines in the other defines.  JAB */

#define BIT_1            1U
#define BIT_2            2U
#define BIT_3            4U
#define BIT_4            8U
#define BIT_5           16U
#define BIT_6           32U
#define BIT_7           64U
#define BIT_8          128U
#define BIT_9          256U
#define BIT_10         512U
#define BIT_11        1024U
#define BIT_12        2048U
#define BIT_13        4096U
#define BIT_14        8192U
#define BIT_15       16384U
#define BIT_16       32768U
#define BIT_17       65536U
#define BIT_18      131072U
#define BIT_19      262144U
#define BIT_20      524288U
#define BIT_21     1048576U
#define BIT_22     2097152U
#define BIT_23     4194304U
#define BIT_24     8388608U
#define BIT_25    16777216U
#define BIT_26    33554432U
#define BIT_27    67108864U
#define BIT_28   134217728U
#define BIT_29   268435456U
#define BIT_30   536870912U
#define BIT_31  1073741824U
#define BIT_32  2147483648U

/* preamble ************************************************************ */

#define NOWHERE    -1		/* nil reference for room-database        */
#define NOTHING	   -1		/* nil reference for objects              */
#define NOBODY	   -1		/* nil reference for mobiles              */

#define SPECIAL(name) \
   int (name)(struct char_data *ch, void *me, int cmd, char *command, char *argument, int why_called)

/* misc editor defines ************************************************* */

/* format modes for format_text */
#define FORMAT_INDENT		(1 << 0)

#define EVENTFUNC(name) long (name)(void *event_obj)


/* room-related defines ************************************************ */


/* The cardinal directions: used as index to room_data.dir_option[] */
#define NORTH          0
#define EAST           1
#define SOUTH          2
#define WEST           3
#define UP             4
#define DOWN           5
#define NORTHEAST      6
#define NORTHWEST      7
#define SOUTHEAST      8
#define SOUTHWEST      9


/* Room map specials */
#define ROOM_MAP_SPECIALS_NONE	  	  (1 << 0)
#define ROOM_MAP_SPECIALS_COLUMNS	  (1 << 1)
#define ROOM_MAP_SPECIALS_RIVER		  (1 << 2)

#define NUM_ROOM_MAP_SPECIALS		3

/* Room flags: used in room_data.room_flags */
/* WARNING: In the world files, NEVER set the bits marked "R" ("Reserved") */
#define ROOM_DARK		(1 << 0)	/* Dark                   */
#define ROOM_DEATH		(1 << 1)	/* Death trap             */
#define ROOM_NOMOB		(1 << 2)	/* MOBs not allowed               */
#define ROOM_INDOORS		(1 << 3)	/* Indoors                        */
#define ROOM_PEACEFUL		(1 << 4)	/* Violence not allowed   */
#define ROOM_SOUNDPROOF		(1 << 5)	/* Shouts, gossip blocked */
#define ROOM_NOTRACK		(1 << 6)	/* Track won't go through */
#define ROOM_NOMAGIC		(1 << 7)	/* Magic not allowed              */
#define ROOM_TUNNEL		(1 << 8)	/* room for only 1 pers   */
#define ROOM_PRIVATE		(1 << 9)	/* Can't teleport in              */
#define ROOM_GODROOM		(1 << 10)	/* LVL_GOD+ only allowed  */
#define ROOM_HOUSE		(1 << 11)	/* (R) Room is a house    */
#define ROOM_HOUSE_CRASH	(1 << 12)	/* (R) House needs saving */
#define ROOM_ATRIUM		(1 << 13)	/* (R) The door to a house        */
#define ROOM_OLC		(1 << 14)	/* (R) Modifyable/!compress       */
#define ROOM_BFS_MARK		(1 << 15)	/* (R) breath-first srch mrk      */
#define ROOM_MOB_GEN		(1 << 16)	/* Mob distribution Room */
#define ROOM_JAIL		(1 << 17)

/* Exit info: used in room_data.dir_option.exit_info */
#define EX_ISDOOR		(1 << 0)	/* Exit is a door         */
#define EX_CLOSED		(1 << 1)	/* The door is closed     */
#define EX_LOCKED		(1 << 2)	/* The door is locked     */
#define EX_PICKPROOF		(1 << 3)	/* Lock can't be picked   */
#define EX_SECRET		(1 << 4)	/* Must search to reveal  */
#define EX_BLOCKED		(1 << 5)	/* Must trigger to open   */
#define EX_WALLED		(1 << 6)	/* A spell is blocking it */
#define EX_LARGE		(1 << 7)	/* Extra wide door, 3 squares */
#define EX_STAIRS		(1 << 8)	/* Is the up a stair, or wall? */
#define EX_NOWALL		(1 << 9)	/* No walls, entire size of room */
#define EX_NOSEE		(1 << 10)	/* Not a door, only set as one */
					   /* so we can get map fancy    */
#define EX_LADDER		(1 << 11)	/* vertical stair, may fall*/
#define EX_STONE		(1 << 12)	/* tough to break */
#define EX_METAL		(1 << 13)
#define EX_SMASHED		(1 << 14)	/* they got through 	*/
#define EX_NOMOB		(1 << 15)	/* similar to nomob rooms*/
#define EX_SPIKED		(1 << 16)	/* A spike holds is position      */
#define EX_TWOOD		(1 << 17)	/* thicker 		*/
#define EX_TSTONE		(1 << 18)
#define EX_TMETAL		(1 << 19)
#define EX_BARS			(1 << 20)
#define NUM_DOOR_FLAGS		21

/* Room shapes: */
#define ROOM_SHAPE_SQUARE 	0
#define ROOM_SHAPE_CIRCLE	1
#define ROOM_SHAPE_OCTAGON	2
#define ROOM_SHAPE_ROUGH	3
#define ROOM_SHAPE_WILDERNESS	4
#define ROOM_SHAPE_PCMAP	5

#define NUM_ROOM_SHAPES		6

/* Sector types: used in room_data.sector_type */
#define SECT_INSIDE          0	/* Indoors                        */
#define SECT_CITY            1	/* In a city                      */
#define SECT_FIELD           2	/* In a field             */
#define SECT_FOREST          3	/* In a forest            */
#define SECT_HILLS           4	/* In the hills           */
#define SECT_MOUNTAIN        5	/* On a mountain          */
#define SECT_WATER_SWIM      6	/* Swimmable water                */
#define SECT_WATER_NOSWIM    7	/* Water - need a boat    */
#define SECT_UNDERWATER	     8	/* Underwater             */
#define SECT_FLYING	     9	/* Wheee!                 */
#define SECT_ROAD	     10	/* Any road or street     */
#define SECT_SWAMP	     11	/* In a swamp             */
#define SECT_CAVE	     12	/* Underground            */
#define SECT_DESERT	     13 /* Land of the cactus	  */
#define SECT_TUNDRA	     14 /* Icy cold flatlands  	  */

/* char and mob-related defines **************************************** */


/* PC classes */
#define CLASS_UNDEFINED	  -1
#define CLASS_CLERIC      0
#define CLASS_DRUID	  1
#define CLASS_FIGHTER     2
#define CLASS_PALADIN	  3
#define CLASS_RANGER	  4
#define CLASS_MAGIC_USER  5
#define CLASS_ILLUSIONIST 6
#define CLASS_THIEF	  7
#define CLASS_BARD	  8
#define CLASS_MULTI_C_M   9
#define CLASS_MULTI_F_M   10
#define CLASS_MULTI_F_T   11
#define CLASS_MULTI_M_T   12
#define CLASS_MULTI_F_M_T 13
#define CLASS_MULTI_C_R   14
#define CLASS_MULTI_C_F   15
#define CLASS_MULTI_I_T   16
#define CLASS_MULTI_C_F_M 17
#define CLASS_MULTI_C_T   18
#define CLASS_MULTI_F_I   19
#define CLASS_MULTI_C_I   20

#define NUM_CLASSES	  21	/* This must be the number of classes!! */

/* Races */
#define RACE_NONE             0
#define RACE_HUMAN            1
#define RACE_HALFELF          2
#define RACE_ELF              3
#define RACE_DWARF            4
#define RACE_HALFLING         5
#define RACE_GNOME            6
#define RACE_HALFORC	      7
#define RACE_BARBARIAN        8
#define RACE_P_DROW           9
#define RACE_P_DUERGAR       10
#define RACE_P_OGRE          11
#define RACE_P_TROLL         12
#define RACE_P_ILLITHID      13
#define RACE_P_ORC           14
#define RACE_P_GOBLIN        15
#define NUM_PC_RACES         15

/* leaving a 10 slot 'gap' here, should be enough to handle future races */
/* stealing some of these outright from the silly src, smile */

#define RACE_ANKHEG			30
#define RACE_AARAKOCRA			31
#define RACE_ABOLETH			32
#define RACE_ARCANE			33
#define RACE_ARGOS			34
#define RACE_BAATEZU			35
#define RACE_AURUMVORAX			36
#define RACE_DROW			37
#define RACE_BANSHEE			38
#define RACE_BASILISK			39
#define RACE_BAT			40
#define RACE_BEAR			41
#define RACE_BEETLE_GIANT		42
#define RACE_BEHOLDER			43
#define RACE_BEHIR			44
#define RACE_BIRD			45
#define RACE_BRAIN_MOLE			46
#define RACE_BROWNIE			47
#define RACE_BUGBEAR			48
#define RACE_BULETTE			49
#define RACE_BULLYWUG			50
#define RACE_CARRION_CRAWLER		51
#define RACE_CAT_GREAT			52
#define RACE_CATOBLEPAS			53
#define RACE_CAVE_FISHER		54
#define RACE_CENTAUR			55
#define RACE_CENTIPEDE			56
#define RACE_CHIMERA			57
#define RACE_GORGIMERA			58
#define RACE_CLOAKER			59
#define RACE_COCKATRICE			60
#define RACE_COUATL			61
#define RACE_CRABMAN			62
#define RACE_CRAWLING_CLAW		63
#define RACE_CROCODILE			64
#define RACE_CRUSTACEAN_GIANT		65
#define RACE_CRYPT_THING		66
#define RACE_DEATH_KNIGHT		67
#define RACE_DEEPSPAWN			68
#define RACE_DINOSAUR			69
#define RACE_DISPLACER_BEAST		70
#define RACE_DOG			71
#define RACE_DOLPHIN			72
#define RACE_DOPPLEGANGER		73
#define RACE_DRACOLICH			74
#define RACE_DRAGON			75
#define RACE_FAERIE_DRAGON		76
#define RACE_FIREDRAKE			77
#define RACE_PSEUDODRAGON		78
#define RACE_DRAGONNE			79
#define RACE_DRYAD			80
#define RACE_ELEMENTAL_AIR		81
#define RACE_ELEMENTAL_EARTH		82
#define RACE_ELEMENTAL_FIRE		83
#define RACE_ELEMENTAL_WATER		84
#define RACE_ELEPHANT			85
#define RACE_ETTERCAP			86
#define RACE_EYEWING			87
#define RACE_FEYR			88
#define RACE_FISH			89
#define RACE_FROG			90
#define RACE_FUNGUS			91
#define RACE_GALEB_DUHR			92
#define RACE_GARGOYLE			93
#define RACE_GENIE			94
#define RACE_GHOST			95
#define RACE_GHOUL			96
#define RACE_GIANT			97
#define RACE_GIBBERLING			98
#define RACE_GIFF			99
#define RACE_GITH			100
#define RACE_GITHYANKI			101
#define RACE_GITHZERAI			102
#define RACE_GNOLL			103
#define RACE_GOBLIN			104
#define RACE_GOLEM			105
#define RACE_GORGON			106
#define RACE_GRELL			107
#define RACE_GREMLIN			108
#define RACE_GRIFFON			109
#define RACE_GRIMLOCK			110
#define RACE_GRIPPLI			111
#define RACE_HAG			112
#define RACE_HARPY			113
#define RACE_HATORI			114
#define RACE_HAUNT			115
#define RACE_HELL_HOUND			116
#define RACE_HEUCUVA			117
#define RACE_HIPPOCAMPUS		118
#define RACE_HIPPOGRIFF			119
#define RACE_HOBGOBLIN			120
#define RACE_HOMONCULOUS		121
#define RACE_HOOK_HORROR		122
#define RACE_HORSE			123
#define RACE_HYDRA			124
#define RACE_IMP			125
#define RACE_INSECT			126
#define RACE_INTELLECT_DEVOURER		127
#define RACE_INVISIBLE_STALKER		128
#define RACE_IXITXACHITL		129
#define RACE_JACKELWERE			130
#define RACE_KENKU			131
#define RACE_KI_RIN			132
#define RACE_KIRRE			133
#define RACE_KOBOLD			134
#define RACE_KUO_TOA			135
#define RACE_LAMIA			136
#define RACE_LAMMASU			137
#define RACE_LEECH			138
#define RACE_LEPRECHAUN			139
#define RACE_LEUCROTTA			140
#define RACE_LICH			141
#define RACE_LIVING_WALL		142
#define RACE_LIZARD			143
#define RACE_LIZARD_MAN			144
#define RACE_LOCATHAH			145
#define RACE_LURKER			146
#define RACE_LYCANTHROPE		147
#define RACE_MAMMAL			148
#define RACE_MANSCORPION		149
#define RACE_MANTICORE			150
#define RACE_MEDUSA			151
#define RACE_MEADAR			152
#define RACE_MERMAN			153
#define RACE_MIMIC			154
#define RACE_MIND_FLAYER		155
#define RACE_MINOTAUR			156
#define RACE_MIST			157
#define RACE_MOLD			158
#define RACE_MONGRELMAN			159
#define RACE_MORKOTH			160
#define RACE_MUCKDWELLER		161
#define RACE_MUDMAN			162
#define RACE_MUMMY			163
#define RACE_MYCONID			164
#define RACE_NAGA			165
#define RACE_NEOGI			166
#define RACE_NIGHTMARE			167
#define RACE_NYMPH			168
#define RACE_OCTOPUS			169
#define RACE_OGRE			170
#define RACE_OGRE_MAGE			171
#define RACE_SLIME			172
#define RACE_ORC			173
#define RACE_OTYUGH			174
#define RACE_OWLBEAR			175
#define RACE_PEGASUS			176
#define RACE_PERYTON			177
#define RACE_PHANTOM			178
#define RACE_PHOENIX			179
#define RACE_PIERCER			180
#define RACE_PLANT			181
#define RACE_POLTERGEIST		182
#define RACE_PUDDING			183
#define RACE_QUAGGOTH			184
#define RACE_RAKSHASA			185
#define RACE_RAT			186
#define RACE_REMORHAZ			187
#define RACE_REVENANT			188
#define RACE_ROC			189
#define RACE_ROPER			190
#define RACE_RUST_MONSTER		191
#define RACE_SAHUAGIN			192
#define RACE_SATYR			193
#define RACE_SCORPION			194
#define RACE_SEA_LION			195
#define RACE_SELKIE			196
#define RACE_SHADOW			197
#define RACE_SHEDU			198
#define RACE_SIRINE			199
#define RACE_SKELETON			200
#define RACE_SLAAD			201
#define RACE_SLUG			202
#define RACE_SNAKE			203
#define RACE_SPECTRE			204
#define RACE_SPHINX			205
#define RACE_SPIDER			206
#define RACE_SPRITE			207
#define RACE_SQUID			208
#define RACE_STIRGE			209
#define RACE_SU_MONSTER			210
#define RACE_SWANMAY			211
#define RACE_TABAXI			212
#define RACE_TAKO			213
#define RACE_TANARRI			214
#define RACE_TARRASQUE			215
#define RACE_TASLOI			216
#define RACE_THOUGHT_EATER		217
#define RACE_THRI_KREEN			218
#define RACE_TITAN			219
#define RACE_TOAD			220
#define RACE_TREANT			221
#define RACE_TRITON			222
#define RACE_TROGLODYTE			223
#define RACE_TROLL			224
#define RACE_UMBER_HULK			225
#define RACE_UNICORN			226
#define RACE_URCHIN			227
#define RACE_VAMPIRE			228
#define RACE_WEMIC			229
#define RACE_WHALE			230
#define RACE_WIGHT			231
#define RACE_WILL_O_WISP		232
#define RACE_WOLF			233
#define RACE_WOLFWERE			234
#define RACE_WORM			235
#define RACE_WRAITH			236
#define RACE_WYVERN			237
#define RACE_XORN			238
#define RACE_YETI			239
#define RACE_YAUN_TI			240
#define RACE_YUGOLOTH			241
#define RACE_ZARATAN			242
#define RACE_ZOMBIE			243

#define NUM_RACES 	     		244


#define KINGDOM_NONE		0
#define KINGDOM_BISSEL		1
#define KINGDOM_BLACKMOOR	2
#define KINGDOM_CELENE		3
#define KINGDOM_DYVERS		4
#define KINGDOM_FURYONDY	5
#define KINGDOM_GEOFF		6
#define KINGDOM_GRAN_MARCH	7
#define KINGDOM_GREYHAWK	8
#define KINGDOM_IDEE		9
#define KINGDOM_IRONGATE	10
#define KINGDOM_KEOLAND	11
#define KINGDOM_N_PROVINCE	12
#define KINGDOM_NYROND		13
#define KINGDOM_ONNWAL		14
#define KINGDOM_THEOCRACY	15
#define KINGDOM_POMARJ		16
#define KINGDOM_SHIELD_LANDS	17
#define KINGDOM_S_PROVINCE	18
#define KINGDOM_SPINDRIFT	19
#define KINGDOM_ULEK		20
#define KINGDOM_URNST		21
#define KINGDOM_VERBOBONC	22
/* set constants.c as well... */
#define NUM_KINGDOMS		23

/* Sex */
#define SEX_NEUTRAL   0
#define SEX_MALE      1
#define SEX_FEMALE    2

/* alignment */
#define ALIGN_NONE            0
#define ALIGN_LAWFUL_GOOD     1
#define ALIGN_NEUTRAL_GOOD    2
#define ALIGN_CHAOTIC_GOOD    3
#define ALIGN_LAWFUL_NEUTRAL  4
#define ALIGN_NEUTRAL_NEUTRAL 5
#define ALIGN_CHAOTIC_NEUTRAL 6
#define ALIGN_LAWFUL_EVIL     7
#define ALIGN_NEUTRAL_EVIL    8
#define ALIGN_CHAOTIC_EVIL    9

#define NUM_ALIGNMENT         10

/* these are for proc calls, using the variable why_called */
#define PROC_NORMAL	0
#define PROC_HIT	1
#define PROC_CRIT_HIT	2
#define PROC_DIE	3
#define PROC_CRIPPLE	4
#define PROC_CRIT_MISS	5


/* these two work together to give us many possible positions. */
/* postures */
#define POS_PRONE       0
#define POS_KNEELING    1
#define POS_SITTING     2
#define POS_STANDING    3
#define NUM_POSITIONS	4

/* status */
#define STAT_DEAD       BIT_3
#define STAT_DYING      BIT_4
#define STAT_INCAP      BIT_5
#define STAT_STUNNED    STAT_INCAP
#define STAT_SLEEPING   BIT_6
#define STAT_RESTING    BIT_7
#define STAT_NORMAL     BIT_8
#define STAT_MASK       (BIT_9 - 4)

#define HIT_INCAP      -3	/* The hit level for incapacitation   */
#define HIT_MORTALLYW  -6	/* The hit level for mortally wound   */
#define HIT_DEAD       -11	/* The point you never want to get to */

/* For players : Prompt flags (16 bits max) */
#define PROMPT_NONE        (1 << 0)
#define PROMPT_HIT         (1 << 1)
#define PROMPT_MAX_HIT     (1 << 2)
#define PROMPT_TANK_COND   (1 << 3)
#define PROMPT_TANK_NAME   (1 << 4)
#define PROMPT_ENEMY       (1 << 5)
#define PROMPT_ENEMY_COND  (1 << 6)
#define PROMPT_VIS         (1 << 7)
#define PROMPT_TWOLINE     (1 << 8)
#define PROMPT_WARN	   (1 << 9)
#define PROMPT_FACE	   (1 << 10)
#define PROMPT_POSITION    (1 << 11)

/* Player flags: used by char_data.char_specials.act */


#define PLR_FROZEN	(1 << 2)	/* Player is frozen                       */
#define PLR_DONTSET     (1 << 3)	/* Don't EVER set (ISNPC bit)     */
#define PLR_WRITING	(1 << 4)	/* Player writing (board/mail/olc)        */
#define PLR_MAILING	(1 << 5)	/* Player is writing mail         */
#define PLR_CRASH	(1 << 6)	/* Player needs to be crash-saved */
#define PLR_SITEOK	(1 << 7)	/* Player has been site-cleared   */
#define PLR_NOSHOUT	(1 << 8)	/* Player not allowed to shout/goss       */
#define PLR_NOTITLE	(1 << 9)	/* Player not allowed to set title        */
#define PLR_DELETED	(1 << 10)	/* Player deleted - space reusable        */
#define PLR_LOADROOM	(1 << 11)	/* Player uses nonstandard loadroom       */
#define PLR_NOWIZLIST	(1 << 12)	/* Player shouldn't be on wizlist */
#define PLR_NODELETE	(1 << 13)	/* Player shouldn't be deleted    */
#define PLR_INVSTART	(1 << 14)	/* Player should enter game wizinvis      */
#define PLR_CRYO	(1 << 15)	/* Player is cryo-saved (purge prog)      */
#define PLR_AFK		(1 << 16)	/* Player is not near the computer        */

/* Mobile flags: used by char_data.char_specials.act */
#define MOB_SPEC         (1 << 0)	/* Mob has a callable spec-proc   */
#define MOB_SENTINEL     (1 << 1)	/* Mob should not move            */
#define MOB_SCAVENGER    (1 << 2)	/* Mob picks up stuff on the ground       */
#define MOB_ISNPC        (1 << 3)	/* (R) Automatically set on all Mobs      */
#define MOB_AWARE	 (1 << 4)	/* Mob can't be backstabbed               */
#define MOB_AGGRESSIVE   (1 << 5)	/* Mob hits players in the room   */
#define MOB_STAY_SECTOR  (1 << 6)	/* Mob shouldn't wander out of sector   */
#define MOB_WIMPY        (1 << 7)	/* Mob flees if severely injured  */
#define MOB_SLOW	 (1 << 8)	/* Wanders 66% slower than normal */

#define MOB_MEMORY	 (1 << 11)	/* remember attackers if attacked */
#define MOB_HELPER	 (1 << 12)	/* attack PCs fighting other NPCs */
#define MOB_NOCHARM	 (1 << 13)	/* Mob can't be charmed           */
#define MOB_NOSUMMON	 (1 << 14)	/* Mob can't be summoned          */
#define MOB_NOSLEEP	 (1 << 15)	/* Mob can't be slept             */
#define MOB_NOBASH	 (1 << 16)	/* Mob can't be bashed (e.g. trees)       */
#define MOB_NOBLIND	 (1 << 17)	/* Mob can't be blinded           */
#define MOB_MOUNTABLE	 (1 << 18)	// Is the mob mountable? (DAK)
#define MOB_NOPOISON	BIT_19		// Mob can't be poisoned
#define MOB_NOHOLD	BIT_20		// Mob can't be paralyzed
#define MOB_IMMFIRE	BIT_21		// Immune to fire
#define MOB_IMMCOLD	BIT_22		//Immune to cold
#define MOB_IMMELEC	BIT_23		// Immune to electricity
#define MOB_IMMILLU	BIT_24		// Immune to illusions

/* number of queues to use (reduces enqueue cost) */
#define NUM_EVENT_QUEUES    100
#define MAX_SKILL_USAGE        20 /* max number of skills with usage timers, PFILE! */

/* Preference flags: used by char_data.player_specials.pref */
#define PRF_PAGING      (1 << 0)	/* Prefer page_string or send_to? */
#define PRF_COMPACT     (1 << 1)	/* No extra CRLF pair before prompts      */
#define PRF_DEAF	(1 << 2)	/* Can't hear shouts              */ 
#define PRF_NOTELL	(1 << 3)	/* Can't receive tells            */
#define PRF_ROOMFLAGS	(1 << 4)	/* Can see room flags (ROOM_x)    */
#define PRF_NOHASSLE	(1 << 5)	/* Aggr mobs won't attack         */
#define PRF_NOREPEAT	(1 << 6)	/* No repetition of comm commands */
#define PRF_HOLYLIGHT	(1 << 7)	/* Can see in dark                */
#define PRF_NOWIZ	(1 << 8)	/* Can't hear wizline             */
#define PRF_LOG1	(1 << 9)	/* On-line System Log (low bit)   */
#define PRF_LOG2	(1 << 10)	/* On-line System Log (high bit)  */
#define PRF_GUILDTALK   (1 << 11)	/* Can hear guild talk */
#define PRF_MUDFTP      (1 << 12) 	/* Use mudFTP transfer system.    */
#define PRF_TURN	(1 << 13)	/* Turn instead of Move*/
#define PRF_PUMMEL	(1 << 14)	/* no damage is given in battle	  */
#define NUM_PREF	15

/* Affect bits: used in char_data.char_specials.saved.affected_by */
/* WARNING: In the world files, NEVER set the bits marked "R" ("Reserved") */

#define NUM_AFF	24

/* Bitvector for 'affected_by'.  Also, used for object bitvectors -DCL */
#define AFF_BLIND             BIT_1
#define AFF_INVISIBLE         BIT_2


#define AFF_HASTE             BIT_5

#define AFF_MINOR_GLOBE       BIT_7
#define AFF_TAMED   	      BIT_8
#define AFF_IDENTIFY          BIT_9
#define AFF_GROUP             BIT_10
#define AFF_SCRIBING	      BIT_11
#define AFF_WATERBREATH       BIT_12
#define AFF_CURSE             BIT_13

#define AFF_POISON            BIT_15


#define AFF_SLEEP             BIT_18
#define AFF_WATERWALK	      BIT_19
#define AFF_SNEAK             BIT_20
#define AFF_HIDE              BIT_21
#define AFF_FEAR              BIT_22
#define AFF_CHARM             BIT_23
#define AFF_LORE              BIT_24
#define AFF_BARKSKIN          BIT_25
#define AFF_INFRAVISION       BIT_26
#define AFF_LEVITATE          BIT_27
#define AFF_FLY               BIT_28
#define AFF_NOTRACK	      BIT_29

#define AFF_CAMPING           BIT_31
#define AFF_MEMORIZING	      BIT_32

/* affected_by2 */

#define AFF2_FIRESHIELD       BIT_1
#define AFF2_ULTRAVISION      BIT_2


#define AFF2_SLOW_POISON      BIT_5
#define AFF2_CHANGE_SELF      BIT_6


#define AFF2_MINOR_PARALYSIS  BIT_9
#define AFF2_MAJOR_PARALYSIS  BIT_10
#define AFF2_SLOW             BIT_11
#define AFF2_GLOBE            BIT_12


#define AFF2_POISONED         BIT_15
#define AFF2_COMPREHEND_LANG  BIT_16
#define AFF2_SILENCED         BIT_17
#define AFF2_MINOR_INVIS      BIT_18
#define AFF2_GAZE_REFLECTION  BIT_19
#define AFF2_STUNNED          BIT_20
#define AFF2_DROPPED_PRIM     BIT_21
#define AFF2_DROPPED_SECOND   BIT_22
#define AFF2_FUMBLING_PRIM    BIT_23
#define AFF2_FUMBLING_SECOND  BIT_24
#define AFF2_HOLDING_BREATH   BIT_25	/* Underwater */
#define AFF2_SHIELD           BIT_26
#define AFF2_IS_DROWNING      BIT_27	/* Underwater */
#define AFF2_PASSDOOR         BIT_28
#define AFF2_DRAINING         BIT_29
#define AFF2_CASTING          BIT_30
#define AFF2_SPIDER_CLIMB     BIT_31
#define AFF2_HUNTER           BIT_32

/* affected_by 3 */

#define AFF3_TENSORS_DISC       BIT_1
#define AFF3_TRACKING           BIT_2
#define AFF3_SINGING            BIT_3
#define AFF3_ALTER_SELF         BIT_4
#define AFF3_BLUR               BIT_5
#define AFF3_BLINK              BIT_6
#define AFF3_HOLD               BIT_7
#define AFF3_POLYMORPH          BIT_8
#define AFF3_NON_DETECTION      BIT_9
#define AFF3_SILVER             BIT_10	/* Char needs silver to dam  */
#define AFF3_PLUSONE            BIT_11	/* Char needs +1 to damage   */
#define AFF3_PLUSTWO            BIT_12	/* Char needs +2 to damage   */
#define AFF3_PLUSTHREE          BIT_13	/* Char needs +3 to damage   */
#define AFF3_PLUSFOUR           BIT_14	/* Char needs +4 to damage   */
#define AFF3_PLUSFIVE           BIT_15	/* Char needs +5 to damage   */
#define AFF3_ENLARGE            BIT_16
#define AFF3_REDUCE             BIT_17
#define AFF3_COVER              BIT_18
#define AFF3_FOUR_ARMS          BIT_19
#define AFF3_ANTI_MAGIC_SHELL   BIT_20
#define AFF3_TRUE_SIGHT         BIT_21
#define AFF3_COLDSHIELD         BIT_22
#define AFF3_MIND_BLANK         BIT_23
#define AFF3_SWIMMING           BIT_24
#define AFF3_SHAPE_CHANGE       BIT_25
#define AFF3_UNDERWATER         BIT_26
#define AFF3_TIME_STOP          BIT_27
#define AFF3_NECKBITING         BIT_28	/* gith mana regain action */
#define AFF3_ELEMENTAL_FORM     BIT_29
#define AFF3_PASS_WITHOUT_TRACE BIT_30

#define AFF3_FREE_ACTION        BIT_32

#define AFF4_LOOTER             BIT_1	/* Just looted someone, prevent rent */
#define AFF4_CARRY_DISEASE      BIT_2
#define AFF4_SACKING            BIT_3	/* sacking a guildhall */
#define AFF4_SENSE_FOLLOWER     BIT_4
#define AFF4_WIND_WALK          BIT_5
#define AFF4_CLAIR		BIT_6
#define AFF4_VAMPIRE_FORM       BIT_7
#define AFF4_NO_UNMORPH         BIT_8	/* can't return .. */
#define AFF4_FAERIE_FIRE        BIT_9
#define AFF4_FEINT		BIT_10
#define AFF4_GALLOP		BIT_11
#define AFF4_SANCTUARY		BIT_12
#define AFF4_THROAT_CRUSH	BIT_13
#define AFF4_REGENERATION	BIT_14
#define AFF4_BEARHUG	        BIT_15
#define AFF4_GRAPPLE            BIT_16
#define AFF4_GRAPPLED           BIT_17
#define AFF4_DEAF               BIT_18
#define AFF4_WRAITHFORM         BIT_19
#define AFF4_SLNT_MOVE          BIT_20



#define AFF4_KNOCKED_OUT        BIT_23
#define AFF4_BOUND              BIT_24

#define AFF4_STONE_SKIN         BIT_26

/* languages */
#define TALK_USING	0
#define TALK_COMMON	1
#define TALK_ELF	2
#define TALK_DWARF	3
#define TALK_GOBLIN	4
#define TALK_HALFLING	5
#define TALK_HOBGOBLIN	6
#define TALK_KOBOLD	7
#define TALK_LIZARDMAN	8
#define TALK_OGRE	9
#define TALK_ORC	10
#define TALK_GNOME	11
#define TALK_ANIMAL	12
#define TALK_MAGIC	13
#define TALK_PLANT	14

#define LAST_HEARD	15
#define LAST_TALK	15

/* Modes of connectedness: used by descriptor_data.state */
#define CON_PLAYING	 0	/* Playing - Nominal state        */
#define CON_CLOSE	 1	/* Disconnecting          */
#define CON_GET_NAME	 2	/* By what name ..?               */
#define CON_NAME_CNFRM	 3	/* Did I get that right, x?       */
#define CON_PASSWORD	 4	/* Password:                      */
#define CON_NEWPASSWD	 5	/* Give me a password for x       */
#define CON_CNFPASSWD	 6	/* Please retype password:        */
#define CON_RMOTD	 7	/* PRESS RETURN after MOTD        */
#define CON_MENU	 8	/* Your choice: (main menu)       */
#define CON_EXDESC	 9	/* Enter a new description:       */
#define CON_CHPWD_GETOLD 10	/* Changing passwd: get old       */
#define CON_CHPWD_GETNEW 11	/* Changing passwd: get new       */
#define CON_CHPWD_VRFY   12	/* Verify new password            */
#define CON_DELCNF1	 13	/* Delete confirmation 1  */
#define CON_DELCNF2	 14	/* Delete confirmation 2  */
#define CON_OEDIT	 15	/*. OLC mode - object edit     . */
#define CON_REDIT	 16	/*. OLC mode - room edit       . */
#define CON_ZEDIT	 17	/*. OLC mode - zone info edit  . */
#define CON_MEDIT	 18	/*. OLC mode - mobile edit     . */
#define CON_SEDIT	 19	/*. OLC mode - shop edit       . */
#define CON_GEDIT	 20	/*. OLC mode - guild edit      . */
#define CON_QEDIT	 21	/*. OLC mode - quest edit      . */
#define CON_HEDIT	 22	/*. OLC mode - helpfile edit   . */
#define CON_PEDIT	 23	/*. OLC mode - Player edit     . */
#define CON_AEDIT        24	/*. OLC mode - action edit     . */
#define CON_TEDIT	 25
#define CON_TERM         26
#define CON_FTP_COMMAND  27
#define CON_FTP_DATA     28
#define CON_FTP_AUTH     29
#define CON_IDCONING	 30		/* waiting for ident connection */
#define CON_IDCONED	 31		/* ident connection complete    */
#define CON_IDREADING	 32		/* waiting to read ident sock   */
#define CON_IDREAD	 33		/* ident results read           */
#define CON_ASKNAME	 34		/* Ask user for name            */

#define NUM_CON		35

/* Character equipment positions: used as index for char_data.equipment[] */
/* NOTE: Don't confuse these constants with the ITEM_ bitvectors
   which control the valid places you can wear a piece of equipment */
#define WEAR_BADGE      0
#define WEAR_HEAD       1
#define WEAR_FACE       2
#define WEAR_EYES       3
#define WEAR_EARRING_R  4
#define WEAR_EARRING_L  5
#define WEAR_NECK       6
#define WEAR_BODY       7
#define WEAR_ABOUT      8
#define WEAR_BACK       9
#define WEAR_ARMS      10
#define WEAR_WRIST_R   11
#define WEAR_WRIST_L   12
#define WEAR_FINGER_R  13
#define WEAR_FINGER_L  14
#define WEAR_HANDS     15
#define WEAR_WAIST     16
#define WEAR_ATTACH_1  17
#define WEAR_ATTACH_2  18
#define WEAR_ATTACH_3  19
#define WEAR_SHIELD    20
#define WEAR_WIELD     21
#define WEAR_WIELD2    22
#define WEAR_HOLD      23
#define WEAR_HOLD2     24
#define WEAR_LEGS      25
#define WEAR_FEET      26

#define NUM_WEARS      27	/* This must be the # of eq positions!! */

/* object materials */
#define MATERIAL_UNDEFINED	0
#define MATERIAL_NONSUBSTANTIAL	1
#define MATERIAL_FLESH		2
#define MATERIAL_CLOTH		3
#define MATERIAL_BARK		4
#define MATERIAL_SOFTWOOD	5
#define MATERIAL_HARDWOOD	6
#define MATERIAL_SILICON	7
#define MATERIAL_CRYSTAL	8
#define MATERIAL_CERAMIC	9
#define MATERIAL_BONE		10
#define MATERIAL_STONE		11
#define MATERIAL_HIDE		12
#define MATERIAL_LEATHER	13
#define MATERIAL_CURED_LEATHER	14
#define MATERIAL_IRON		15
#define MATERIAL_STEEL		16
#define MATERIAL_BRASS		17
#define MATERIAL_MITHRIL	18
#define MATERIAL_ADAMANTIUM	19
#define MATERIAL_BRONZE		20
#define MATERIAL_COPPER		21
#define MATERIAL_SILVER		22
#define MATERIAL_ELECTRUM	23
#define MATERIAL_GOLD		24
#define MATERIAL_PLATINUM	25
#define MATERIAL_GEM		26
#define MATERIAL_DIAMOND	27
#define MATERIAL_PAPER		28
#define MATERIAL_PARCHMENT	29
#define MATERIAL_LEAVES		30
#define MATERIAL_RUBY		31
#define MATERIAL_EMERALD	32
#define MATERIAL_SAPPHIRE	33
#define MATERIAL_IVORY		34
#define MATERIAL_DRAGONSCALE	35
#define MATERIAL_OBSIDIAN	36
#define MATERIAL_GRANITE	37
#define MATERIAL_MARBLE		38
#define MATERIAL_LIMESTONE	39
#define MATERIAL_LIQUID		40
#define MATERIAL_BAMBOO		41
#define MATERIAL_REEDS		42
#define MATERIAL_HEMP		43
#define MATERIAL_GLASSTEEL	44
#define MATERIAL_EGGSHELL	45
#define MATERIAL_CHITINOUS	46
#define MATERIAL_REPTILESCALE	47
#define MATERIAL_GENERICFOOD	48
#define MATERIAL_RUBBER		49
#define MATERIAL_FEATHER	50
#define MATERIAL_WAX		51
#define MATERIAL_PEARL		52
#define MATERIAL_ELEMENT	53
#define MATERIAL_ORGANIC	54
#define MATERIAL_METAL		55
#define NUM_MATERIALS		56

/* obj size */
#define ITEM_SIZE_NONE       0
#define ITEM_SIZE_TINY       1
#define ITEM_SIZE_SMALL      2
#define ITEM_SIZE_SM         3
#define ITEM_SIZE_MEDIUM     4
#define ITEM_SIZE_ML         5
#define ITEM_SIZE_LARGE      6
#define ITEM_SIZE_HUGE       7
#define ITEM_SIZE_GIANT      8
#define ITEM_SIZE_GARGANTUAN 9

#define ITEM_SIZE_MAGICAL    10

/* mob size */
#define SIZE_NONE       0
#define SIZE_TINY       1
#define SIZE_SMALL      2
#define SIZE_SM         3
#define SIZE_MEDIUM     4
#define SIZE_ML         5
#define SIZE_LARGE      6
#define SIZE_HUGE       7
#define SIZE_GIANT      8
#define SIZE_GARGANTUAN 9

/* object-related defines ******************************************* */


/* Item types: used by obj_data.obj_flags.type_flag */
#define ITEM_LIGHT      1	/* Item is a light source */
#define ITEM_SCROLL     2	/* Item is a scroll               */
#define ITEM_WAND       3	/* Item is a wand         */
#define ITEM_STAFF      4	/* Item is a staff                */
#define ITEM_WEAPON     5	/* Item is a weapon               */
#define ITEM_FIREWEAPON 6	/* Unimplemented          */
#define ITEM_MISSILE    7	/* Unimplemented          */
#define ITEM_TREASURE   8	/* Item is a treasure, not gold   */
#define ITEM_ARMOR      9	/* Item is armor          */
#define ITEM_POTION    10	/* Item is a potion               */
#define ITEM_WORN      11	/* Unimplemented          */
#define ITEM_OTHER     12	/* Misc object                    */
#define ITEM_TRASH     13	/* Trash - shopkeeps won't buy    */
#define ITEM_TRAP      14	/* Unimplemented          */
#define ITEM_CONTAINER 15	/* Item is a container            */
#define ITEM_NOTE      16	/* Item is note           */
#define ITEM_DRINKCON  17	/* Item is a drink container      */
#define ITEM_KEY       18	/* Item is a key          */
#define ITEM_FOOD      19	/* Item is food                   */
#define ITEM_MONEY     20	/* Item is money (gold)           */
#define ITEM_PEN       21	/* Item is a pen          */
#define ITEM_BOAT      22	/* Item is a boat         */
#define ITEM_FOUNTAIN  23
#define ITEM_BOARD     24	/* Item is a board                */
#define ITEM_BOOK      25	/* Magical book usually           */
#define ITEM_WALL      26	/* Wall of force, etc */
#define ITEM_CORPSE    27	/* internal use only, do NOT assign this type! */
#define ITEM_TELEPORT  28	/* item can be used to teleport */
#define ITEM_TIMER     29	/* used chiefly to load/activate traps */
#define ITEM_VEHICLE   30	/* Like ships, but can 'follow' mobs (carraige) */
#define ITEM_SHIP      31	/* item which represents a sea-going vessel */
#define ITEM_SWITCH    32	/* item is a trigger for a switch proc */
#define ITEM_QUIVER    33	/* container for MISSILEs only */
#define ITEM_PICK      34	/* lockpicks */
#define ITEM_INSTRUMENT 35	/* bard's instruments */
#define ITEM_FURNITURE 36	/* Genuine magetype spellbook */
#define ITEM_STORAGE   37	/* like a container, but saves itself */
#define ITEM_SCABBARD  38	/* weapon scabbard */
#define ITEM_SHIELD    39	/* dedicated type for shields */
#define ITEM_TROOP     40	/* troop item type */
#define ITEM_HOLY_SYMBOL 41	/* troop item type */
#define ITEM_PIT       42	/* Like item_teleport, but enter not req. */
#define ITEM_DOOR	43
#define ITEM_MAP_CONNECTOR 44	/* a virtual door for the wilderness */

#define PC_CORPSE       BIT_1
#define NPC_CORPSE      BIT_2
#define MISSING_SKULL   BIT_3
#define MISSING_SCALP   BIT_4
#define MISSING_FACE    BIT_5
#define MISSING_EYES    BIT_6
#define MISSING_EARS    BIT_7
#define MISSING_TONGUE  BIT_8
#define MISSING_BOWELS  BIT_9
#define MISSING_ARMS    BIT_10
#define MISSING_LEGS    BIT_11
#define HUMANOID_CORPSE BIT_16

/* Take/Wear flags: used by obj_data.obj_flags.wear_flags */
#define ITEM_TAKE		(1 << 0)	/* Item can be takes              */
#define ITEM_WEAR_TAKE          (1 << 0)
#define ITEM_WEAR_FINGER	(1 << 1)	/* Can be worn on finger  */
#define ITEM_WEAR_NECK		(1 << 2)	/* Can be worn around neck        */
#define ITEM_WEAR_BODY		(1 << 3)	/* Can be worn on body    */
#define ITEM_WEAR_HEAD		(1 << 4)	/* Can be worn on head    */
#define ITEM_WEAR_LEGS		(1 << 5)	/* Can be worn on legs    */
#define ITEM_WEAR_FEET		(1 << 6)	/* Can be worn on feet    */
#define ITEM_WEAR_HANDS		(1 << 7)	/* Can be worn on hands   */
#define ITEM_WEAR_ARMS		(1 << 8)	/* Can be worn on arms    */
#define ITEM_WEAR_SHIELD	(1 << 9)	/* Can be used as a shield        */
#define ITEM_WEAR_ABOUT		(1 << 10)	/* Can be worn about body         */
#define ITEM_WEAR_WAIST 	(1 << 11)	/* Can be worn around waist       */
#define ITEM_WEAR_WRIST		(1 << 12)	/* Can be worn on wrist   */
#define ITEM_WEAR_WIELD		(1 << 13)	/* Can be wielded         */
#define ITEM_WEAR_HOLD		(1 << 14)	/* Can be held            */
#define ITEM_LIGHT_SOURCE       (1 << 15)
#define ITEM_WEAR_EYES          (1 << 16)	/* Can be worn on eyes    */
#define ITEM_WEAR_FACE          (1 << 17)	/* Can be worn on face    */
#define ITEM_WEAR_EARRING       (1 << 18)	/* Can be worn on ears    */
#define ITEM_GUILD_INSIGNIA     (1 << 19)	/* Can be worn as badge   */
#define ITEM_WEAR_BACK          (1 << 20)	/* Can be worn on back    */
#define ITEM_ATTACH_BELT        (1 << 21)	/* Can be attach to belt  */


/* Bitvector for 'extra_flags' */

#define ITEM_GLOW          BIT_1
#define ITEM_NOSHOW        BIT_2	/* item is _never_ shown        */
#define ITEM_BURIED        BIT_3
#define ITEM_NOSELL        BIT_4	/* shopkeepers won't buy it     */
#define ITEM_EVIL          BIT_5
#define ITEM_INVISIBLE     BIT_6
#define ITEM_MAGIC         BIT_7
#define ITEM_NODROP        BIT_8
#define ITEM_BLESS         BIT_9
#define ITEM_ANTI_GOOD     BIT_10	/* not usable by good people    */
#define ITEM_ANTI_EVIL     BIT_11	/* not usable by evil people    */
#define ITEM_ANTI_NEUTRAL  BIT_12	/* not usable by neutral people */
#define ITEM_SECRET        BIT_13
#define ITEM_FLOAT         BIT_14
#define ITEM_NOBURN        BIT_15	/* can't be destroyed with dragon breath */
#define ITEM_NOLOCATE      BIT_16	/* Item cannot be located       */
#define ITEM_NOIDENTIFY    BIT_17	/* Item cannot be identified    */
#define ITEM_NOSUMMON      BIT_18	/* if in inventory cannot be summoned */
#define ITEM_LIT           BIT_19	/* Item has a light spell cast on it */
#define ITEM_TRANSIENT     BIT_20	/* Item which dissolves when dropped */
#define ITEM_NOSLEEP       BIT_21	/* If in inventory, cannot be slept */
#define ITEM_NOCHARM       BIT_22	/* If in inventory, cannot be charmed */
#define ITEM_TWOHANDS      BIT_23	/* item requires two hands to hold/wield */
#define ITEM_NORENT        BIT_24	/* item cannot be rented */
#define ITEM_GOOD          BIT_25
#define ITEM_CONCEALED     BIT_26	/* other item hides it, not same as secret */
#define ITEM_LEVITATES     BIT_27
#define ITEM_ONEORTWOHANDS BIT_28	/* item requires two hands to hold/wield */
#define ITEM_WHOLE_BODY    BIT_30
#define ITEM_WHOLE_HEAD    BIT_31
#define ITEM_WAS_DISARMED  BIT_32	/* if disarmed, re-arm in perform_violence */

#define ITEM2_SILVER       BIT_1	/* Item harm AFF_SILVER         */
#define ITEM2_PLUSONE      BIT_2	/* Item harm upto AFF_PLUSONE   */
#define ITEM2_PLUSTWO      BIT_3	/* Item harm upto AFF_PLUSTWO   */
#define ITEM2_PLUSTHREE    BIT_4	/* Item harm upto AFF_PLUSTHREE */
#define ITEM2_PLUSFOUR     BIT_5	/* Item harm upto AFF_PLUSFOUR  */
#define ITEM2_PLUSFIVE     BIT_6	/* Item harm upto AFF_PLUSFIVE  */
#define ITEM2_RETURNING    BIT_7	/* Boomerang item, returns      */
#define ITEM2_CAN_THROW1   BIT_8	/* Item can be thrown 1 room    */
#define ITEM2_CAN_THROW2   BIT_9	/* Item can be thrown 2 rooms   */
#define ITEM2_REMOVE_2HAND BIT_10	/* Needs changing back to single*/
#define ITEM2_ENLARGE      BIT_17	/* item been enlarge */
#define ITEM2_REDUCE       BIT_18	/* item been reduce  */

/* Bitvector for 'anti_flags' */

#define ITEM_ALLOW_ALL         BIT_1
#define ITEM_ALLOW_CLERIC      BIT_2
#define ITEM_ALLOW_DRUID       BIT_3
#define ITEM_ALLOW_FIGHTER     BIT_4
#define ITEM_ALLOW_PALADIN     BIT_5
#define ITEM_ALLOW_RANGER      BIT_6
#define ITEM_ALLOW_MAGIC_USER  BIT_7
#define ITEM_ALLOW_ILLUSIONIST BIT_8
#define ITEM_ALLOW_THIEF       BIT_9
#define ITEM_ALLOW_BARD        BIT_10

#define MONEY_COPPER		0
#define MONEY_SILVER		1
#define MONEY_ELECTRUM		2
#define MONEY_GOLD		3
#define MONEY_PLATINUM		4


/* Modifier constants used with obj affects ('A' fields) */
#define APPLY_NONE              0	/* No effect                      */
#define APPLY_STR               1	/* Apply to strength              */
#define APPLY_DEX               2	/* Apply to dexterity             */
#define APPLY_INT               3	/* Apply to constitution  */
#define APPLY_WIS               4	/* Apply to wisdom                */
#define APPLY_CON               5	/* Apply to constitution  */
#define APPLY_CHA		6	/* Apply to charisma              */
#define APPLY_CLASS             7	/* Reserved                       */
#define APPLY_LEVEL             8	/* Reserved                       */
#define APPLY_AGE               9	/* Apply to age                   */
#define APPLY_CHAR_WEIGHT      10	/* Apply to weight                */
#define APPLY_CHAR_HEIGHT      11	/* Apply to height                */
#define APPLY_HIT              12	/* Apply to max hit points        */
#define APPLY_MAGIC_RES        13	/* Reserved                       */
#define APPLY_EXP              14	/* Reserved                       */
#define APPLY_AC               15	/* Apply to Armor Class           */
#define APPLY_HITROLL          16	/* Apply to hitroll               */
#define APPLY_DAMROLL          17	/* Apply to damage roll           */
#define APPLY_SAVING_PARA      18	/* Apply to save throw: paralz    */
#define APPLY_SAVING_ROD       19	/* Apply to save throw: rods      */
#define APPLY_SAVING_PETRI     20	/* Apply to save throw: petrif    */
#define APPLY_SAVING_BREATH    21	/* Apply to save throw: breath    */
#define APPLY_SAVING_SPELL     22	/* Apply to save throw: spells    */
#define APPLY_SAVING_ALL       23	/* Apply to all save throw        */
#define APPLY_MAX_STR          24	/* Change str to number, 26=18/100 */
#define APPLY_HEARING	       25	/* Apply to hearing checks	  */
#define APPLY_VISION	       26	/* Apply to vision checks	  */

/* Container flags - value[1] */
#define CONT_CLOSEABLE      (1 << 0)	/* Container can be closed        */
#define CONT_PICKPROOF      (1 << 1)	/* Container is pickproof */
#define CONT_CLOSED         (1 << 2)	/* Container is closed            */
#define CONT_LOCKED         (1 << 3)	/* Container is locked            */

/* Some different kind of liquids for use in values of drink containers */
#define LIQ_WATER      0
#define LIQ_BEER       1
#define LIQ_WINE       2
#define LIQ_ALE        3
#define LIQ_DARKALE    4
#define LIQ_WHISKY     5
#define LIQ_LEMONADE   6
#define LIQ_FIREBRT    7
#define LIQ_LOCALSPC   8
#define LIQ_SLIME      9
#define LIQ_MILK       10
#define LIQ_TEA        11
#define LIQ_COFFE      12
#define LIQ_BLOOD      13
#define LIQ_SALTWATER  14
#define LIQ_CLEARWATER 15

/* Basic furniture */
#define FURN_THRONE	1
#define FURN_CHAIR	2
#define FURN_TABLE	3
#define FURN_BOOKCASE	4
#define FURN_BED	5
#define FURN_COUNTER	6
#define FURN_DESK	7
/* be sure to update constants.c and utils.h */
#define NUM_FURN_TYPES	8


/* other miscellaneous defines ****************************************** */


/* Player conditions */
#define DRUNK        0
#define FULL         1
#define THIRST       2


/* Sun state */
#define SUN_DARK	0
#define SUN_RISE	1
#define SUN_LIGHT	2
#define SUN_SET		3


/* Sky conditions */
#define SKY_CLOUDLESS	0
#define SKY_CLOUDY	1
#define SKY_RAINING	2
#define SKY_LIGHTNING	3


/* Rent codes */
#define RENT_UNDEF      0
#define RENT_CRASH      1
#define RENT_RENTED     2
#define RENT_CRYO       3
#define RENT_FORCED     4
#define RENT_TIMEDOUT   5

//Target locations
#define LOCATION_ALL -1
#define LOCATION_VITALS 0
#define LOCATION_BRAIN 1
#define LOCATION_FACE 2
#define LOCATION_SHIELD_ARM 3
#define LOCATION_SHIELD_HAND 4
#define LOCATION_WEAPON_HAND 5
#define LOCATION_WEAPON_ARM 6
#define LOCATION_TORSO 7
#define LOCATION_RIGHT_LEG 8
#define LOCATION_LEFT_LEG 9
#define LOCATION_RIGHT_FOOT 10
#define LOCATION_LEFT_FOOT 11
#define NUMBER_LOCATIONS 12 //last + 1

//Style types
#define STYLE_AGGRESSIVE 0
#define STYLE_NORMAL 1
#define STYLE_DEFENSIVE 2

//Weapon Strike Types
#define STK_UNDEFINED 	0
#define STK_CRUSH 	1
#define STK_IMPALE 	2
#define STK_CUT 	3
#define STK_CUT_IMP	4
#define STK_IMP_CSH	5
#define STK_CUT_CSH	6

//Weapon Definitions
#define WEAPON_UNDEFINED	0
#define WEAPON_BATTLE_AXE	1
#define WEAPON_BOW		2
#define WEAPON_CLUB		3
#define WEAPON_CROSSBOW		4
#define WEAPON_DAGGER		5
#define WEAPON_DART		6
#define WEAPON_FLAIL		7
#define WEAPON_MACE		8
#define WEAPON_PICK		9
#define WEAPON_HAMMER		10
#define WEAPON_HAND_AXE		11
#define WEAPON_HARPOON		12
#define WEAPON_JAVELIN		13
#define WEAPON_KNIFE		14
#define WEAPON_LANCE		15
#define WEAPON_MANCATCHER	16
#define WEAPON_MORNING_STAR	17
#define WEAPON_POLEARM		18
#define WEAPON_STAFF		19
#define WEAPON_SCOURGE		20
#define WEAPON_SICKLE		21
#define WEAPON_SLING		22
#define WEAPON_SPEAR		23
#define WEAPON_STAFF_SLING	24
#define WEAPON_BASTARD_SWORD	25
#define WEAPON_BROAD_SWORD	26
#define WEAPON_KHOPESH		27
#define WEAPON_LONG_SWORD	28
#define WEAPON_SHORT_SWORD	29
#define WEAPON_TWO_HANDED_SWORD	30
#define WEAPON_TRIDENT		31
#define WEAPON_WHIP		32
#define WEAPON_RAPIER		33
#define WEAPON_SABER		34

//which is dominant hand
#define HAND_RIGHT 	0
#define HAND_LEFT	1
#define HAND_BOTH	2

/* other #defined constants ********************************************* */

/*
 * **DO**NOT** blindly change the number of levels in your MUD merely by
 * changing these numbers and without changing the rest of the code to match.
 * Other changes throughout the code are required.  See coding.doc for
 * details.
 *
 * LVL_IMPL should always be the HIGHEST possible immortal level, and
 * LVL_IMMORT should always be the LOWEST immortal level.  The number of
 * mortal levels will always be LVL_IMMORT - 1.
 */
#define LVL_IMPL	40
#define LVL_GRGOD	39
#define LVL_GOD7	38
#define LVL_GOD6	37
#define LVL_GOD5	36
#define LVL_GOD4	35
#define LVL_GOD3	34
#define LVL_GOD2	33
#define LVL_GOD1	32
#define LVL_GOD		LVL_GOD1
#define LVL_IMMORT	31

/* Level of the 'freeze' command */
#define LVL_FREEZE	LVL_GRGOD

#define NUM_OF_DIRS	10	/* number of directions in a room (nsewud) */
#define NUM_EXITS	NUM_OF_DIRS /* I can never rememeber this one */
#define NUM_DIRS	NUM_OF_DIRS

#define OPT_USEC	100000	/* 10 passes per second */
#define PASSES_PER_SEC	(1000000 / OPT_USEC)
#define RL_SEC		* PASSES_PER_SEC

#define PULSE_ZONE      (10 RL_SEC)
#define PULSE_MOBILE    (1 RL_SEC)
#define PULSE_SPEC 	(5 RL_SEC)
#define PULSE_VIOLENCE  (PASSES_PER_SEC / 5) /* every .2 secs */
#define PULSE_PATH	(10 RL_SEC)	/* oh sure, you could make it smaller */
#define MOBILE_PERCENT  10	/* Do 1 in 10 of specials per mobile pulse. */
#define RANDOM_M_PERCENT 5	/* triggers */
#define RANDOM_O_PERCENT 5	/* triggers */

/* Variables for the output buffering system */
#define MAX_SOCK_BUF            (12 * 1024)	/* Size of kernel's sock buf   */
#define MAX_PROMPT_LENGTH       256	/* Max length of prompt        */
#define GARBAGE_SPACE		32	/* Space for **OVERFLOW** etc  */
#define SMALL_BUFSIZE		1024	/* Static output buffer size   */
/* Max amount of output that can be buffered */
#define LARGE_BUFSIZE	   (MAX_SOCK_BUF - GARBAGE_SPACE - MAX_PROMPT_LENGTH)

#define MAX_STRING_LENGTH	24576	/* 307+ 80 character lines */
#define MAX_INPUT_LENGTH	512	/* Max length per *line* of input */
#define MAX_RAW_INPUT_LENGTH	1024	/* Max size of *raw* input */
#define MAX_MESSAGES		60
#define MAX_NAME_LENGTH		20	/* Used in char_file_u *DO*NOT*CHANGE* */
#define MAX_PWD_LENGTH		10	/* Used in char_file_u *DO*NOT*CHANGE* */
#define MAX_TITLE_LENGTH	80	/* Used in char_file_u *DO*NOT*CHANGE* */
#define MAX_SHORTDESC_LENGTH  	80	/* Used in char_file_u *DO*NOT*CHANGE* */
#define MAX_INTRO		50	/* Used in char_file_u *DO*NOT*CHANGE* */
#ifndef PWIPE
#define HOST_LENGTH		30	/* Used in char_file_u *DO*NOT*CHANGE* */
#else
#define HOST_LENGTH		50	/* Used in char_file_u *DO*NOT*CHANGE* */
#endif
#define EXDSCR_LENGTH		240	/* Used in char_file_u *DO*NOT*CHANGE* */
#define MAX_TONGUE		50	/* Used in char_file_u *DO*NOT*CHANGE* */
#define MAX_SKILLS		500	/* Used in char_file_u *DO*NOT*CHANGE* */
#define MAX_SPELLS		520	/* Used in char_file_u *DO*NOT*CHANGE* */
#define MAX_CIRCLE		9
#define MAX_AFFECT		32	/* Used in char_file_u *DO*NOT*CHANGE* */
#define MAX_OBJ_AFFECT		6	/* Used in obj_file_elem *DO*NOT*CHANGE* */
#define POOF_LENGTH		256
#define MAX_COMPLETED_QUESTS	1024


#define PATH_NONE      0
#define PATH_GOTO      1
#define PATH_ACTION    2

/* These are for various mob attacks, used in mob.combat.c only */
#define ATTACK_BASH	1
#define ATTACK_KICK	2
#define ATTACK_HIT	3
#define ATTACK_CAST	4


#define PROT_FROM_ACID		BIT_1
#define PROT_FROM_COLD		BIT_2
#define PROT_FROM_DRAGON_BREATH	BIT_3
#define PROT_FROM_ELECTRICITY   BIT_4
#define PROT_FROM_ELEMENTALS    BIT_5
#define PROT_FROM_FIRE          BIT_6
#define PROT_FROM_GAS           BIT_7
#define PROT_FROM_LYCANTHROPES  BIT_8
#define PROT_FROM_MAGIC         BIT_9	/* NOT the same as magic resistance! */
#define PROT_FROM_PETRIFICATION BIT_10
#define PROT_FROM_PLANTS        BIT_11
#define PROT_FROM_POISON        BIT_12
#define PROT_FROM_POSSESION     BIT_13
#define PROT_FROM_UNDEAD        BIT_14
#define PROT_FROM_WATER         BIT_15
#define PROT_FROM_EVIL		BIT_16
#define PROT_FROM_EVIL_10	BIT_17
#define PROT_FROM_GOOD		BIT_18
#define PROT_FROM_GOOD_10	BIT_19

#define DETECTING_ALIGN		BIT_1
#define DETECTING_GOOD		BIT_2
#define DETECTING_EVIL		BIT_3
#define DETECTING_INVIS		BIT_4
#define DETECTING_LIFE		BIT_5
#define DETECTING_MAGIC		BIT_6

