/*****************************************************************/
/*                      World of GreyHawk                        */
/*      Begun in 1998, originally based on Circle3.0 and others  */
/* File:                                                         */
/* Purpose:                                                      */
/*****************************************************************/

#include "conf.h"
#include "sysdep.h"

#include "structs.h"
#include "utils.h"
#include "comm.h"
#include "spells.h"
#include "handler.h"
#include "db.h"

#ifndef DEBUG_GRANOR
#define DEBUG_GRANOR 1
#endif

extern struct room_data *world;
extern struct obj_data *object_list;
extern struct char_data *character_list;
extern struct cha_app_type cha_app[];
extern struct int_app_type int_app[];
extern struct index_data *obj_index;

extern struct weather_data weather_info;
extern struct descriptor_data *descriptor_list;
extern struct zone_data *zone_table;

extern int mini_mud;

extern struct default_mobile_stats *mob_defaults;
extern char weapon_verbs[];
extern int *max_ac_applys;
extern struct apply_mod_defaults *apmd;
extern struct spell_info_type spell_info[];

void clearMemory(struct char_data *ch);
void act(char *str, int i, struct char_data *c, struct obj_data *o,
	 void *vict_obj, int j);

void damage(struct char_data *ch, struct char_data *victim,
	    int damage, int weapontype, int which, int location);

void weight_change_object(struct obj_data *obj, int weight);
void add_follower(struct char_data *ch, struct char_data *leader);

// First Level Cleric Spells
/*
   CSPELL(cast_spell_animal_friendship) {
   switch (casttype) {
   case CAST_SPELL:
   spell_animal_friendship(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for animal friendship.", ch);
   break;
   }
   }
 */
CSPELL(cast_spell_bless)
{
  switch (casttype) {
  case CAST_SPELL:
    spell_bless(level, ch, victim, obj, loc, savetype, casttype);
    break;
  default:
    send_to_char("Error, this is not a proper type for bless.", ch);
    break;
  }
}
/*
   CSPELL(cast_spell_combine)
   {
   switch (casttype) {
   case CAST_SPELL:
   spell_combine(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for combine.", ch);
   break;
   }
   }

   CSPELL(cast_spell_command)
   {
   switch (casttype) {
   case CAST_SPELL:
   spell_command(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for command.", ch);
   break;
   }
   }
 */
CSPELL(cast_spell_create_water)
{
  switch (casttype) {
  case CAST_SPELL:
    spell_create_water(level, ch, victim, obj, loc, savetype, casttype);
    break;
  default:
    send_to_char("Error, this is not a proper type for create water.", ch);
    break;
  }
}
/*
   CSPELL(cast_spell_cause_fear)
   {
   switch (casttype) {
   case CAST_SPELL:
   spell_cause_fear(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for cause fear.", ch);
   break;
   }
   }
 */
CSPELL(cast_spell_cause_light)
{
  switch (casttype) {
  case CAST_SPELL:
    spell_cause_light(level, ch, victim, obj, loc, savetype, casttype);
    break;
  default:
    send_to_char("Error, this is not a proper type for cause light.", ch);
    break;
  }
}

CSPELL(cast_spell_cure_light)
{
  switch (casttype) {
  case CAST_SPELL:
  case CAST_SCROLL:
    spell_cure_light(level, ch, victim, obj, loc, savetype, casttype);
    break;
  case CAST_POTION:
    spell_cure_light(level, ch, ch, obj, loc, savetype, casttype);
    break;
  default:
    send_to_char("Error, this is not a proper type for cure light.", ch);
    break;
  }
}

CSPELL(cast_spell_curse)
{
  switch (casttype) {
  case CAST_SPELL:
  case CAST_SCROLL:
    spell_curse(level, ch, victim, obj, loc, savetype, casttype);
    break;
  default:
    send_to_char("Error, this is not a proper type for curse.", ch);
    break;
  }
}
/*
   CSPELL(cast_spell_darkness)
   {
   switch (casttype) {
   case CAST_SPELL:
   case CAST_SCROLL:
   spell_darkness(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for darkness.", ch);
   break;
   }
   }

   CSPELL(cast_spell_destroy_water)
   {
   switch (casttype) {
   case CAST_SPELL:
   case CAST_SCROLL:
   spell_destroy_water(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for destroy water.", ch);
   break;
   }
   }

   CSPELL(cast_spell_detect_evil)
   {
   switch (casttype) {
   case CAST_SPELL:
   spell_detect_evil(level, ch, victim, obj, loc, savetype, casttype);
   break;
   case CAST_SCROLL:
   case CAST_POTION:
   spell_detect_evil(level, ch, ch, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for detect evil.", ch);
   break;
   }
   }

   CSPELL(cast_spell_detect_good)
   {
   switch (casttype) {
   case CAST_SPELL:
   spell_detect_good(level, ch, victim, obj, loc, savetype, casttype);
   break;
   case CAST_SCROLL:
   case CAST_POTION:
   spell_detect_good(level, ch, ch, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for detect good.", ch);
   break;
   }
   }

   CSPELL(cast_spell_detect_magic)
   {
   switch (casttype) {
   case CAST_SPELL:
   spell_detect_magic(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for detect magic.", ch);
   break;
   }
   }
 */
CSPELL(cast_spell_detect_poison)
{
  switch (casttype) {
  case CAST_SPELL:
    spell_detect_poison(level, ch, victim, obj, loc, savetype, casttype);
    break;
  default:
    send_to_char("Error, this is not a proper type for detect poison.", ch);
    break;
  }
}
/*
   CSPELL(cast_spell_detect_snares_and_pits)
   {
   switch (casttype) {
   case CAST_SPELL:
   spell_detect_snares_and_pits(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for detect snares and pits.", ch);
   break;
   }
   }

   CSPELL(cast_spell_endure_heat_endure_cold)
   {
   switch (casttype) {
   case CAST_SPELL:
   spell_endure_heat_endure_cold(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for endure heat/endure cold.", ch);
   break;
   }
   }

   CSPELL(cast_spell_entangle)
   {
   switch (casttype) {
   case CAST_SPELL:
   spell_entangle(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for entangle.", ch);
   break;
   }
   }
 */
CSPELL(cast_spell_faerie_fire)
{
  switch (casttype) {
  case CAST_SPELL:
    spell_faerie_fire(level, ch, victim, obj, loc, savetype, casttype);
    break;
  default:
    send_to_char("Error, this is not a proper type for faerie fire.", ch);
    break;
  }
}
/*
   CSPELL(cast_spell_light)
   {
   switch (casttype) {
   case CAST_SPELL:
   spell_light(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for light.", ch);
   break;
   }
   }

   CSPELL(cast_spell_locate_animals_or_plants)
   {
   switch (casttype) {
   case CAST_SPELL:
   spell_locate_animals_or_plants(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for locate animals or plants.", ch);
   break;
   }
   }

   CSPELL(cast_spell_magical_stone)
   {
   switch (casttype) {
   case CAST_SPELL:
   spell_magical_stone(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for magical stone.", ch);
   break;
   }
   }

   CSPELL(cast_spell_pass_without_trace)
   {
   switch (casttype) {
   case CAST_SPELL:
   spell_pass_without_trace(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for pass without trace.", ch);
   break;
   }
   }

   CSPELL(cast_spell_protection_from_good)
   {
   switch (casttype) {
   case CAST_SPELL:
   spell_protection_from_evil(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for protection from good.", ch);
   break;
   }
   }

   CSPELL(cast_spell_protection_from_evil)
   {
   switch (casttype) {
   case CAST_SPELL:
   spell_protection_from_evil(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for protection from evil.", ch);
   break;
   }
   }

   CSPELL(cast_spell_purify_food_and_drink)
   {
   switch (casttype) {
   case CAST_SPELL:
   spell_purify_food_and_drink(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for purify food and drink.", ch);
   break;
   }
   }

   CSPELL(cast_spell_putrefy_food_and_drink)
   {
   switch (casttype) {
   case CAST_SPELL:
   spell_putrefy_food_and_drink(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for putrefy food and drink.", ch);
   break;
   }
   }

   CSPELL(cast_spell_remove_fear)
   {
   switch (casttype) {
   case CAST_SPELL:
   spell_remove_fear(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for remove fear.", ch);
   break;
   }
   }
 */
CSPELL(cast_spell_sanctuary)
{
  switch (casttype) {
  case CAST_SPELL:
    spell_sanctuary(level, ch, victim, obj, loc, savetype, casttype);
    break;
  default:
    send_to_char("Error, this is not a proper type for sanctuary.", ch);
    break;
  }
}
/*

   CSPELL(cast_spell_shillelagh)
   {
   switch (casttype) {
   case CAST_SPELL:
   spell_shillelagh(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for shillelagh.", ch);
   break;
   }
   }
 */
// Second Level Cleric Spells

CSPELL(cast_spell_aid)
{
  switch (casttype) {
  case CAST_SPELL:
    spell_aid(level, ch, victim, obj, loc, savetype, casttype);
    break;
  default:
    send_to_char("Error, this is not a proper type for aid.", ch);
    break;
  }
}
/*
   CSPELL(cast_spell_augury)
   {
   switch (casttype) {
   case CAST_SPELL:
   spell_augury(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for augury.", ch);
   break;
   }
   }

   CSPELL(cast_spell_badberry)
   {
   switch (casttype) {
   case CAST_SPELL:
   spell_badberry(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for badberry.", ch);
   break;
   }
   }
 */
CSPELL(cast_spell_barkskin)
{
  switch (casttype) {
  case CAST_SPELL:
    spell_barkskin(level, ch, victim, obj, loc, savetype, casttype);
    break;
  default:
    send_to_char("Error, this is not a proper type for barkskin.", ch);
    break;
  }
}
/*
   CSPELL(cast_spell_chant)
   {
   switch (casttype) {
   case CAST_SPELL:
   spell_chant(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for chant.", ch);
   break;
   }
   }
 */
CSPELL(cast_spell_charm_mammal)
{
  switch (casttype) {
  case CAST_SPELL:
    spell_charm_mammal(level, ch, victim, obj, loc, savetype, casttype);
    break;
  default:
    send_to_char("Error, this is not a proper type for charm mammal.", ch);
    break;
  }
}
/*
   CSPELL(cast_spell_chill_metal)
   {
   switch (casttype) {
   case CAST_SPELL:
   spell_chill_metal(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for chill metal.", ch);
   break;
   }
   }

   CSPELL(cast_spell_detect_charm)
   {
   switch (casttype) {
   case CAST_SPELL:
   spell_detect_charm(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for detect charm.", ch);
   break;
   }
   }

   CSPELL(cast_spell_dust_devil)
   {
   switch (casttype) {
   case CAST_SPELL:
   spell_dust_devil(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for dust devil.", ch);
   break;
   }
   }

   CSPELL(cast_spell_enthrall)
   {
   switch (casttype) {
   case CAST_SPELL:
   spell_enthrall(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for enthrall.", ch);
   break;
   }
   }

   CSPELL(cast_spell_find_traps)
   {
   switch (casttype) {
   case CAST_SPELL:
   spell_find_traps(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for find traps.", ch);
   break;
   }
   }

   CSPELL(cast_spell_fire_trap)
   {
   switch (casttype) {
   case CAST_SPELL:
   spell_fire_trap(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for fire trap.", ch);
   break;
   }
   }

   CSPELL(cast_spell_flame_blade)
   {
   switch (casttype) {
   case CAST_SPELL:
   spell_flame_blade(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for flame blade.", ch);
   break;
   }
   }

   CSPELL(cast_spell_goodberry)
   {
   switch (casttype) {
   case CAST_SPELL:
   spell_goodberry(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for goodberry.", ch);
   break;
   }
   }

   CSPELL(cast_spell_heat_metal)
   {
   switch (casttype) {
   case CAST_SPELL:
   spell_heat_metal(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for heat metal.", ch);
   break;
   }
   }

   CSPELL(cast_spell_hold_person)
   {
   switch (casttype) {
   case CAST_SPELL:
   spell_hold_person(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for hold person.", ch);
   break;
   }
   }

   CSPELL(cast_spell_know_alignment)
   {
   switch (casttype) {
   case CAST_SPELL:
   spell_know_alignment(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for know alignment.", ch);
   break;
   }
   }

   CSPELL(cast_spell_messenger)
   {
   switch (casttype) {
   case CAST_SPELL:
   spell_messenger(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for messenger.", ch);
   break;
   }
   }

   CSPELL(cast_spell_obscurement)
   {
   switch (casttype) {
   case CAST_SPELL:
   spell_obscurement(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for obscurement.", ch);
   break;
   }
   }

   CSPELL(cast_spell_produce_flame)
   {
   switch (casttype) {
   case CAST_SPELL:
   spell_produce_flame(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for produce flame.", ch);
   break;
   }
   }

   CSPELL(cast_spell_resist_fire_resist_cold)
   {
   switch (casttype) {
   case CAST_SPELL:
   spell_resist_fire_resist_cold(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for resist fire/resist cold.", ch);
   break;
   }
   }

   CSPELL(cast_spell_silence_15)
   {
   switch (casttype) {
   case CAST_SPELL:
   spell_silence_15(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for silence, 15' radius.", ch);
   break;
   }
   }

   CSPELL(cast_spell_slow_poison)
   {
   switch (casttype) {
   case CAST_SPELL:
   spell_slow_poison(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for slow poison.", ch);
   break;
   }
   }

   CSPELL(cast_spell_snake_charm)
   {
   switch (casttype) {
   case CAST_SPELL:
   spell_snake_charm(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for snake charm.", ch);
   break;
   }
   }

   CSPELL(cast_spell_speak_with_animals)
   {
   switch (casttype) {
   case CAST_SPELL:
   spell_speak_with_animals(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for speak with animals.", ch);
   break;
   }
   }

   CSPELL(cast_spell_spiritual_hammer)
   {
   switch (casttype) {
   case CAST_SPELL:
   spell_spiritual_hammer(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for spiritual hammer.", ch);
   break;
   }
   }

   CSPELL(cast_spell_straighten_wood)
   {
   switch (casttype) {
   case CAST_SPELL:
   spell_straighten_wood(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for straighten wood.", ch);
   break;
   }
   }

   CSPELL(cast_spell_trip)
   {
   switch (casttype) {
   case CAST_SPELL:
   spell_trip(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for trip.", ch);
   break;
   }
   }

   CSPELL(cast_spell_undetectable_alignment)
   {
   switch (casttype) {
   case CAST_SPELL:
   spell_undetectable_alignment(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for undetectable alignment.", ch);
   break;
   }
   }

   CSPELL(cast_spell_undetectable_charm)
   {
   switch (casttype) {
   case CAST_SPELL:
   spell_undetectable_charm(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for undetectable charm.", ch);
   break;
   }
   }

   CSPELL(cast_spell_warp_wood)
   {
   switch (casttype) {
   case CAST_SPELL:
   spell_warp_wood(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for warp wood.", ch);
   break;
   }
   }

   CSPELL(cast_spell_withdraw)
   {
   switch (casttype) {
   case CAST_SPELL:
   spell_withdraw(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for withdraw.", ch);
   break;
   }
   }

   CSPELL(cast_spell_wyvern_watch)
   {
   switch (casttype) {
   case CAST_SPELL:
   spell_wyvern_watch(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for wyvern watch.", ch);
   break;
   }
   }
 */
// Third Level Cleric Spells
/*
   CSPELL(cast_spell_air_breathing)
   {
   switch (casttype) {
   case CAST_SPELL:
   spell_air_breathing(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for air breathing.", ch);
   break;
   }
   }

   CSPELL(cast_spell_animate_dead)
   {
   switch (casttype) {
   case CAST_SPELL:
   spell_animate_dead(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for animate dead.", ch);
   break;
   }
   }

   CSPELL(cast_spell_bestow_curse)
   {
   switch (casttype) {
   case CAST_SPELL:
   spell_bestow_curse(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for bestow curse.", ch);
   break;
   }
   }

   CSPELL(cast_spell_call_lightning)
   {
   switch (casttype) {
   case CAST_SPELL:
   spell_call_lightning(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for call lightning.", ch);
   break;
   }
   }
 */
CSPELL(cast_spell_cause_blindness)
{
  switch (casttype) {
  case CAST_SPELL:
    spell_cause_blindness(level, ch, victim, obj, loc, savetype, casttype);
    break;
  default:
    send_to_char("Error, this is not a proper type for cause blindness or deafness.", ch);
    break;
  }
}

CSPELL(cast_spell_cause_deafness)
{
  switch (casttype) {
  case CAST_SPELL:
    spell_cause_deafness(level, ch, victim, obj, loc, savetype, casttype);
    break;
  default:
    send_to_char("Error, this is not a proper type for cause deafness.", ch);
    break;
  }
}
/*
   CSPELL(cast_spell_cause_disease)
   {
   switch (casttype) {
   case CAST_SPELL:
   spell_cause_disease(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for cause disease.", ch);
   break;
   }
   }
   CSPELL(cast_spell_continual_darkness)
   {
   switch (casttype) {
   case CAST_SPELL:
   spell_continual_darkness(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for continual darkness.", ch);
   break;
   }
   }

   CSPELL(cast_spell_continual_light)
   {
   switch (casttype) {
   case CAST_SPELL:
   spell_continual_light(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for continual light.", ch);
   break;
   }
   }

   CSPELL(cast_spell_create_food_and_water)
   {
   switch (casttype) {
   case CAST_SPELL:
   spell_create_food_and_water(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for create food and water.", ch);
   break;
   }
   }
 */
CSPELL(cast_spell_cure_blindness)
{
  switch (casttype) {
  case CAST_SPELL:
    spell_cure_blindness(level, ch, victim, obj, loc, savetype, casttype);
    break;
  default:
    send_to_char("Error, this is not a proper type for cure blindness.", ch);
    break;
  }
}

CSPELL(cast_spell_cure_deafness)
{
  switch (casttype) {
  case CAST_SPELL:
    spell_cure_deafness(level, ch, victim, obj, loc, savetype, casttype);
    break;
  default:
    send_to_char("Error, this is not a proper type for cure deafness.", ch);
    break;
  }
}

/*
   CSPELL(cast_spell_cure_disease)
   {
   switch (casttype) {
   case CAST_SPELL:
   spell_cure_disease(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for cure disease.", ch);
   break;
   }
   }

   CSPELL(cast_spell_dispel_magic)
   {
   switch (casttype) {
   case CAST_SPELL:
   spell_dispel_magic(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for dispel magic.", ch);
   break;
   }
   }

   CSPELL(cast_spell_feign_death)
   {
   switch (casttype) {
   case CAST_SPELL:
   spell_feign_death(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for feign death.", ch);
   break;
   }
   }

   CSPELL(cast_spell_flame_walk)
   {
   switch (casttype) {
   case CAST_SPELL:
   spell_flame_walk(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for flame walk.", ch);
   break;
   }
   }

   CSPELL(cast_spell_glyph_of_warding)
   {
   switch (casttype) {
   case CAST_SPELL:
   spell_glyph_of_warding(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for glyph of warding.", ch);
   break;
   }
   }

   CSPELL(cast_spell_hold_animal)
   {
   switch (casttype) {
   case CAST_SPELL:
   spell_hold_animal(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for hold animal.", ch);
   break;
   }
   }

   CSPELL(cast_spell_locate_object)
   {
   switch (casttype) {
   case CAST_SPELL:
   spell_locate_object(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for locate object.", ch);
   break;
   }
   }

   CSPELL(cast_spell_magical_vestment)
   {
   switch (casttype) {
   case CAST_SPELL:
   spell_magical_vestment(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for magical vestment.", ch);
   break;
   }
   }

   CSPELL(cast_spell_meld_into_stone)
   {
   switch (casttype) {
   case CAST_SPELL:
   spell_meld_into_stone(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for meld into stone.", ch);
   break;
   }
   }

   CSPELL(cast_spell_negative_plane_protection)
   {
   switch (casttype) {
   case CAST_SPELL:
   spell_negative_plane_protection(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for negative plane protection.", ch);
   break;
   }
   }

   CSPELL(cast_spell_obscure_object)
   {
   switch (casttype) {
   case CAST_SPELL:
   spell_obscure_object(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for obscure object.", ch);
   break;
   }
   }
   CSPELL(cast_spell_plant_growth)
   {
   switch (casttype) {
   case CAST_SPELL:
   spell_plant_growth(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for plant growth.", ch);
   break;
   }
   }

   CSPELL(cast_spell_prayer)
   {
   switch (casttype) {
   case CAST_SPELL:
   spell_prayer(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for prayer.", ch);
   break;
   }
   }

   CSPELL(cast_spell_protection_from_fire)
   {
   switch (casttype) {
   case CAST_SPELL:
   spell_protection_from_fire(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for protection from fire.", ch);
   break;
   }
   }

   CSPELL(cast_spell_pyrotechnics)
   {
   switch (casttype) {
   case CAST_SPELL:
   spell_pyrotechnics(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for pyrotechnics.", ch);
   break;
   }
   }

   CSPELL(cast_spell_remove_curse)
   {
   switch (casttype) {
   case CAST_SPELL:
   spell_remove_curse(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for remove curse.", ch);
   break;
   }
   }

   CSPELL(cast_spell_remove_paralysis)
   {
   switch (casttype) {
   case CAST_SPELL:
   spell_paralysis(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for paralysis.", ch);
   break;
   }
   }

   CSPELL(cast_spell_snare)
   {
   switch (casttype) {
   case CAST_SPELL:
   spell_snare(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for snare.", ch);
   break;
   }
   }

   CSPELL(cast_spell_speak_with_dead)
   {
   switch (casttype) {
   case CAST_SPELL:
   spell_speak_with_dead(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for speak with dead.", ch);
   break;
   }
   }

   CSPELL(cast_spell_spike_growth)
   {
   switch (casttype) {
   case CAST_SPELL:
   spell_spike_growth(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for spike growth.", ch);
   break;
   }
   }

   CSPELL(cast_spell_starshine)
   {
   switch (casttype) {
   case CAST_SPELL:
   spell_starshine(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for starshine.", ch);
   break;
   }
   }

   CSPELL(cast_spell_stone_shape)
   {
   switch (casttype) {
   case CAST_SPELL:
   spell_stone_shape(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for stone shape.", ch);
   break;
   }
   }

   CSPELL(cast_spell_summon_insects)
   {
   switch (casttype) {
   case CAST_SPELL:
   spell_summon_insects(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for summon insects.", ch);
   break;
   }
   }

   CSPELL(cast_spell_tree)
   {
   switch (casttype) {
   case CAST_SPELL:
   spell_tree(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for tree.", ch);
   break;
   }
   }

   CSPELL(cast_spell_water_breathing)
   {
   switch (casttype) {
   case CAST_SPELL:
   spell_water_breathing(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for water breathing.", ch);
   break;
   }
   }

   CSPELL(cast_spell_water_walk)
   {
   switch (casttype) {
   case CAST_SPELL:
   spell_water_walk(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for water walk.", ch);
   break;
   }
   }
 */
// Fourth Level Cleric Spells
/*
   CSPELL(cast_spell_abjure)
   {
   switch (casttype) {
   case CAST_SPELL:
   spell_abjure(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for abjure.", ch);
   break;
   }
   }

   CSPELL(cast_spell_animal_summoning_i)
   {
   switch (casttype) {
   case CAST_SPELL:
   spell_animal_summoning_i(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for animal summoning I.", ch);
   break;
   }
   }

   CSPELL(cast_spell_call_woodland_beings)
   {
   switch (casttype) {
   case CAST_SPELL:
   spell_call_woodland_beings(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for call woodland beings.", ch);
   break;
   }
   }
 */
CSPELL(cast_spell_cause_serious)
{
  switch (casttype) {
  case CAST_SPELL:
    spell_cause_serious(level, ch, victim, obj, loc, savetype, casttype);
    break;
  default:
    send_to_char("Error, this is not a proper type for cause serious.", ch);
    break;
  }
}
/*
   CSPELL(cast_spell_cloak_of_bravery)
   {
   switch (casttype) {
   case CAST_SPELL:
   spell_cloak_of_bravery(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for cloak of bravery.", ch);
   break;
   }
   }

   CSPELL(cast_spell_cloak_of_fear)
   {
   switch (casttype) {
   case CAST_SPELL:
   spell_cloak_of_fear(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for cloak of fear.", ch);
   break;
   }
   }

   CSPELL(cast_spell_control_temperature_10)
   {
   switch (casttype) {
   case CAST_SPELL:
   spell_control_temperature_10(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for control temperature, 10' radius.", ch);
   break;
   }
   }
 */
CSPELL(cast_spell_cure_serious)
{
  switch (casttype) {
  case CAST_SPELL:
    spell_cure_serious(level, ch, victim, obj, loc, savetype, casttype);
    break;
  case CAST_POTION:
    spell_cure_serious(level, ch, ch, obj, loc, savetype, casttype);
    break;
  default:
    send_to_char("Error, this is not a proper type for cure serious.", ch);
    break;
  }
}
/*
   CSPELL(cast_spell_detect_lie)
   {
   switch (casttype) {
   case CAST_SPELL:
   spell_detect_lie(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for detect lie.", ch);
   break;
   }
   }

   CSPELL(cast_spell_divination)
   {
   switch (casttype) {
   case CAST_SPELL:
   spell_divination(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for divination.", ch);
   break;
   }
   }

   CSPELL(cast_spell_free_action)
   {
   switch (casttype) {
   case CAST_SPELL:
   spell_free_action(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for free action.", ch);
   break;
   }
   }

   CSPELL(cast_spell_giant_insect)
   {
   switch (casttype) {
   case CAST_SPELL:
   spell_giant_insect(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for giant insect.", ch);
   break;
   }
   }

   CSPELL(cast_spell_hallucinatory_forest)
   {
   switch (casttype) {
   case CAST_SPELL:
   spell_hallucinatory_forest(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for hallucinatory forest.", ch);
   break;
   }
   }

   CSPELL(cast_spell_hallucinatory_forest_reverse)
   {
   switch (casttype) {
   case CAST_SPELL:
   spell_hallucinatory_forest_reverse(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for hallucinatory forest reverse.", ch);
   break;
   }
   }

   CSPELL(cast_spell_hold_plant)
   {
   switch (casttype) {
   case CAST_SPELL:
   spell_hold_plant(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for hold plant.", ch);
   break;
   }
   }

   CSPELL(cast_spell_imbue_with_spell_ability)
   {
   switch (casttype) {
   case CAST_SPELL:
   spell_imbue_with_spell_ability(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for imbue with spell ability.", ch);
   break;
   }
   }

   CSPELL(cast_spell_lower_water)
   {
   switch (casttype) {
   case CAST_SPELL:
   spell_lower_water(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for lower water.", ch);
   break;
   }
   }

   CSPELL(cast_spell_neutralize_poison)
   {
   switch (casttype) {
   case CAST_SPELL:
   spell_neutralize_poison(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for neutralize poison.", ch);
   break;
   }
   }

   CSPELL(cast_spell_plant_door)
   {
   switch (casttype) {
   case CAST_SPELL:
   spell_plant_door(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for plant door.", ch);
   break;
   }
   }

   CSPELL(cast_spell_poison)
   {
   switch (casttype) {
   case CAST_SPELL:
   spell_poison(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for poison.", ch);
   break;
   }
   }

   CSPELL(cast_spell_produce_fire)
   {
   switch (casttype) {
   case CAST_SPELL:
   spell_produce_fire(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for produce fire.", ch);
   break;
   }
   }

   CSPELL(cast_spell_protection_from_good_10)
   {
   switch (casttype) {
   case CAST_SPELL:
   spell_protection_from_good_10(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for protection from good, 10' radius.", ch);
   break;
   }
   }

   CSPELL(cast_spell_protection_from_evil_10)
   {
   switch (casttype) {
   case CAST_SPELL:
   spell_protection_from_evil_10(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for protection from evil, 10' radius.", ch);
   break;
   }
   }

   CSPELL(cast_spell_protection_from_lightning)
   {
   switch (casttype) {
   case CAST_SPELL:
   spell_protection_from_lightning(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for protection from lightning.", ch);
   break;
   }
   }

   CSPELL(cast_spell_quench_fire)
   {
   switch (casttype) {
   case CAST_SPELL:
   spell_quench_fire(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for quench fire.", ch);
   break;
   }
   }

   CSPELL(cast_spell_raise_water)
   {
   switch (casttype) {
   case CAST_SPELL:
   spell_raise_water(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for raise water.", ch);
   break;
   }
   }

   CSPELL(cast_spell_reflecting_pool)
   {
   switch (casttype) {
   case CAST_SPELL:
   spell_reflecting_pool(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for reflecting pool.", ch);
   break;
   }
   }

   CSPELL(cast_spell_repel_insects)
   {
   switch (casttype) {
   case CAST_SPELL:
   spell_repel_insects(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for repel insects.", ch);
   break;
   }
   }

   CSPELL(cast_spell_shrink_insect)
   {
   switch (casttype) {
   case CAST_SPELL:
   spell_shrink_insect(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for shrink insect.", ch);
   break;
   }
   }

   CSPELL(cast_spell_snakes_to_sticks)
   {
   switch (casttype) {
   case CAST_SPELL:
   spell_snakes_to_sticks(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for snakes to sticks.", ch);
   break;
   }
   }

   CSPELL(cast_spell_speak_with_plants)
   {
   switch (casttype) {
   case CAST_SPELL:
   spell_speak_with_plants(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for speak with plants.", ch);
   break;
   }
   }

   CSPELL(cast_spell_spell_immunity)
   {
   switch (casttype) {
   case CAST_SPELL:
   spell_spell_immunity(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for spell immunity.", ch);
   break;
   }
   }

   CSPELL(cast_spell_sticks_to_snakes)
   {
   switch (casttype) {
   case CAST_SPELL:
   spell_sticks_to_snakes(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for sticks to snakes.", ch);
   break;
   }
   }

   CSPELL(cast_spell_tongues)
   {
   switch (casttype) {
   case CAST_SPELL:
   spell_tongues(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for tongues.", ch);
   break;
   }
   }

   CSPELL(cast_spell_tongues_reverse)
   {
   switch (casttype) {
   case CAST_SPELL:
   spell_tongues_reverse(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for tongues reverse.", ch);
   break;
   }
   }

   CSPELL(cast_spell_undetectable_lie)
   {
   switch (casttype) {
   case CAST_SPELL:
   spell_undetectable_lie(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for undetectable lie.", ch);
   break;
   }
   }
 */
// Fifth Level Cleric Spells
/*
   CSPELL(cast_spell_air_walk)
   {
   switch (casttype) {
   case CAST_SPELL:
   spell_air_walk(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for air walk.", ch);
   break;
   }
   }

   CSPELL(cast_spell_animal_growth)
   {
   switch (casttype) {
   case CAST_SPELL:
   spell_animal_growth(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for animal growth.", ch);
   break;
   }
   }

   CSPELL(cast_spell_animal_growth_reverse)
   {
   switch (casttype) {
   case CAST_SPELL:
   spell_animal_growth_reverse(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for animal growth reverse.", ch);
   break;
   }
   }

   CSPELL(cast_spell_animal_summoning_ii)
   {
   switch (casttype) {
   case CAST_SPELL:
   spell_animal_summoning_ii(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for animal summoning ii.", ch);
   break;
   }
   }

   CSPELL(cast_spell_antiplant_shell)
   {
   switch (casttype) {
   case CAST_SPELL:
   spell_antiplant_shell(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for antiplant shell.", ch);
   break;
   }
   }

   CSPELL(cast_spell_atonement)
   {
   switch (casttype) {
   case CAST_SPELL:
   spell_atonement(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for atonement.", ch);
   break;
   }
   }
 */
CSPELL(cast_spell_cause_critic)
{
  switch (casttype) {
  case CAST_SPELL:
    spell_cause_critic(level, ch, victim, obj, loc, savetype, casttype);
    break;
  default:
    send_to_char("Error, this is not a proper type for cause critical.", ch);
    break;
  }
}
/*
   CSPELL(cast_spell_commune)
   {
   switch (casttype) {
   case CAST_SPELL:
   spell_commune(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for commune.", ch);
   break;
   }
   }

   CSPELL(cast_spell_commune_with_nature)
   {
   switch (casttype) {
   case CAST_SPELL:
   spell_commune_with_nature(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for commune with nature.", ch);
   break;
   }
   }
 */
CSPELL(cast_spell_cure_critic)
{
  switch (casttype) {
  case CAST_SPELL:
    spell_cure_critic(level, ch, victim, obj, loc, savetype, casttype);
    break;
  case CAST_POTION:
    spell_cure_critic(level, ch, ch, obj, loc, savetype, casttype);
    break;
  default:
    send_to_char("Error, this is not a proper type for cure critic.", ch);
    break;
  }
}
/*
   CSPELL(cast_spell_dispel_evil)
   {
   switch (casttype) {
   case CAST_SPELL:
   spell_dispel_evil(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for dispel evil.", ch);
   break;
   }
   }

   CSPELL(cast_spell_dispel_good)
   {
   switch (casttype) {
   case CAST_SPELL:
   spell_dispel_good(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for dispel good.", ch);
   break;
   }
   }

   CSPELL(cast_spell_false_seeing)
   {
   switch (casttype) {
   case CAST_SPELL:
   spell_false_seeing(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for false seeing.", ch);
   break;
   }
   }

   CSPELL(cast_spell_flame_strike)
   {
   switch (casttype) {
   case CAST_SPELL:
   spell_flame_strike(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for flame strike.", ch);
   break;
   }
   }

   CSPELL(cast_spell_insect_plague)
   {
   switch (casttype) {
   case CAST_SPELL:
   spell_insect_plague(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for insect plague.", ch);
   break;
   }
   }

   CSPELL(cast_spell_magic_font)
   {
   switch (casttype) {
   case CAST_SPELL:
   spell_magic_font(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for magic font.", ch);
   break;
   }
   }

   CSPELL(cast_spell_moonbeam)
   {
   switch (casttype) {
   case CAST_SPELL:
   spell_moonbeam(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for moonbeam.", ch);
   break;
   }
   }

   CSPELL(cast_spell_pass_plant)
   {
   switch (casttype) {
   case CAST_SPELL:
   spell_pass_plant(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for pass plant.", ch);
   break;
   }
   }

   CSPELL(cast_spell_plane_shift)
   {
   switch (casttype) {
   case CAST_SPELL:
   spell_plane_shift(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for plane shift.", ch);
   break;
   }
   }

   CSPELL(cast_spell_quest)
   {
   switch (casttype) {
   case CAST_SPELL:
   spell_quest(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for quest.", ch);
   break;
   }
   }

   CSPELL(cast_spell_rainbow)
   {
   switch (casttype) {
   case CAST_SPELL:
   spell_rainbow(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for rainbow.", ch);
   break;
   }
   }

   CSPELL(cast_spell_raise_dead)
   {
   switch (casttype) {
   case CAST_SPELL:
   spell_raise_dead(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for raise dead.", ch);
   break;
   }
   }

   CSPELL(cast_spell_slay_living)
   {
   switch (casttype) {
   case CAST_SPELL:
   spell_slay_living(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for slay living.", ch);
   break;
   }
   }

   CSPELL(cast_spell_spike_stones)
   {
   switch (casttype) {
   case CAST_SPELL:
   spell_spike_stones(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for spike stones.", ch);
   break;
   }
   }

   CSPELL(cast_spell_transmute_mud_to_rock)
   {
   switch (casttype) {
   case CAST_SPELL:
   spell_transmute_mud_to_rock(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for transmute mud to rock.", ch);
   break;
   }
   }

   CSPELL(cast_spell_transmute_rock_to_mud)
   {
   switch (casttype) {
   case CAST_SPELL:
   spell_transmute_rock_to_mud(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for transmute rock to mud.", ch);
   break;
   }
   }

   CSPELL(cast_spell_true_seeing)
   {
   switch (casttype) {
   case CAST_SPELL:
   spell_true_seeing(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for true seeing.", ch);
   break;
   }
   }

   CSPELL(cast_spell_wall_of_fire)
   {
   switch (casttype) {
   case CAST_SPELL:
   spell_wall_of_fire(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for wall of fire.", ch);
   break;
   }
   }
 */
// Sixth Level Cleric Spells
/*
   CSPELL(cast_spell_aerial_servant)
   {
   switch (casttype) {
   case CAST_SPELL:
   spell_aerial_servant(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for aerial servant.", ch);
   break;
   }
   }

   CSPELL(cast_spell_animal_summoning_iii)
   {
   switch (casttype) {
   case CAST_SPELL:
   spell_animal_summoning_iii(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for animal summoning III.", ch);
   break;
   }
   }

   CSPELL(cast_spell_animate_object)
   {
   switch (casttype) {
   case CAST_SPELL:
   spell_animate_object(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for animal object.", ch);
   break;
   }
   }

   CSPELL(cast_spell_antianimal_shell)
   {
   switch (casttype) {
   case CAST_SPELL:
   spell_antianimal_shell(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for antianimal shell.", ch);
   break;
   }
   }

   CSPELL(cast_spell_blade_barrier)
   {
   switch (casttype) {
   case CAST_SPELL:
   spell_blade_barrier(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for blade barrier.", ch);
   break;
   }
   }

   CSPELL(cast_spell_conjure_animals)
   {
   switch (casttype) {
   case CAST_SPELL:
   spell_conjure_animals(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for conjure animals.", ch);
   break;
   }
   }

   CSPELL(cast_spell_conjure_fire_elemental)
   {
   switch (casttype) {
   case CAST_SPELL:
   spell_conjure_fire_elemental(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for conjure fire elemental.", ch);
   break;
   }
   }

   CSPELL(cast_spell_conjure_fire_elemental_reverse)
   {
   switch (casttype) {
   case CAST_SPELL:
   spell_conjure_fire_elemental_reverse(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for conjure fire elemental reverse.", ch);
   break;
   }
   }

   CSPELL(cast_spell_find_the_path)
   {
   switch (casttype) {
   case CAST_SPELL:
   spell_find_the_path(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for find the path.", ch);
   break;
   }
   }

   CSPELL(cast_spell_fire_seeds)
   {
   switch (casttype) {
   case CAST_SPELL:
   spell_fire_seeds(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for fire seeds.", ch);
   break;
   }
   }

   CSPELL(cast_spell_forbiddance)
   {
   switch (casttype) {
   case CAST_SPELL:
   spell_forbiddance(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for forbiddance.", ch);
   break;
   }
   }

   CSPELL(cast_spell_harm)
   {
   switch (casttype) {
   case CAST_SPELL:
   spell_harm(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for harm.", ch);
   break;
   }
   }
 */
CSPELL(cast_spell_heal)
{
  switch (casttype) {
  case CAST_SPELL:
    spell_heal(level, ch, victim, obj, loc, savetype, casttype);
    break;
  default:
    send_to_char("Error, this is not a proper type for heal.", ch);
    break;
  }
}
/*
   CSPELL(cast_spell_heroes_feast)
   {
   switch (casttype) {
   case CAST_SPELL:
   spell_heroes_feast(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for heroes feast.", ch);
   break;
   }
   }

   CSPELL(cast_spell_liveoak)
   {
   switch (casttype) {
   case CAST_SPELL:
   spell_liveoak(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for liveoak.", ch);
   break;
   }
   }

   CSPELL(cast_spell_lose_the_path)
   {
   switch (casttype) {
   case CAST_SPELL:
   spell_lose_the_path(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for lose the path.", ch);
   break;
   }
   }

   CSPELL(cast_spell_part_water)
   {
   switch (casttype) {
   case CAST_SPELL:
   spell_part_water(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for part water.", ch);
   break;
   }
   }

   CSPELL(cast_spell_speak_with_monsters)
   {
   switch (casttype) {
   case CAST_SPELL:
   spell_speak_with_monsters(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for speak with monsters.", ch);
   break;
   }
   }

   CSPELL(cast_spell_stone_tell)
   {
   switch (casttype) {
   case CAST_SPELL:
   spell_stone_tell(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for stone tell.", ch);
   break;
   }
   }

   CSPELL(cast_spell_transmute_dust_to_water)
   {
   switch (casttype) {
   case CAST_SPELL:
   spell_transmute_dust_to_water(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for transmute dust to water.", ch);
   break;
   }
   }

   CSPELL(cast_spell_transmute_water_to_dust)
   {
   switch (casttype) {
   case CAST_SPELL:
   spell_transmute_water_to_dust(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for transmute water to dust.", ch);
   break;
   }
   }

   CSPELL(cast_spell_transport_via_plants)
   {
   switch (casttype) {
   case CAST_SPELL:
   spell_transport_via_plants(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for transport via plants.", ch);
   break;
   }
   }

   CSPELL(cast_spell_turn_wood)
   {
   switch (casttype) {
   case CAST_SPELL:
   spell_turn_wood(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for turn wood.", ch);
   break;
   }
   }

   CSPELL(cast_spell_wall_of_thorns)
   {
   switch (casttype) {
   case CAST_SPELL:
   spell_wall_of_thorns(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for wall of thorns.", ch);
   break;
   }
   }

   CSPELL(cast_spell_weather_summoning)
   {
   switch (casttype) {
   case CAST_SPELL:
   spell_weather_summoning(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for weather summoning.", ch);
   break;
   }
   }
 */
CSPELL(cast_spell_word_recall)
{
  switch (casttype) {
  case CAST_SPELL:
    spell_word_recall(level, ch, victim, obj, loc, savetype, casttype);
    break;
  default:
    send_to_char("Error, this is not a proper type for word of recall.", ch);
    break;
  }
}

// Seventh Level Cleric Spells
/*
   CSPELL(cast_spell_animate_rock)
   {
   switch (casttype) {
   case CAST_SPELL:
   spell_animate_rock(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for animate rock.", ch);
   break;
   }
   }

   CSPELL(cast_spell_astral_spell)
   {
   switch (casttype) {
   case CAST_SPELL:
   spell_astral_spell(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for astral spell.", ch);
   break;
   }
   }

   CSPELL(cast_spell_changestaff)
   {
   switch (casttype) {
   case CAST_SPELL:
   spell_changestaff(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for changestaff.", ch);
   break;
   }
   }

   CSPELL(cast_spell_chariot_of_sustarre)
   {
   switch (casttype) {
   case CAST_SPELL:
   spell_chariot_of_sustarre(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for chariot of sustarre.", ch);
   break;
   }
   }

   CSPELL(cast_spell_confusion)
   {
   switch (casttype) {
   case CAST_SPELL:
   spell_confusion(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for confusion.", ch);
   break;
   }
   }

   CSPELL(cast_spell_conjure_earth_elemental)
   {
   switch (casttype) {
   case CAST_SPELL:
   spell_conjure_earth_elemental(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for conjure earth elemental.", ch);
   break;
   }
   }

   CSPELL(cast_spell_conjure_earth_elemental_reverse)
   {
   switch (casttype) {
   case CAST_SPELL:
   spell_conjure_earth_elemental_reverse(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for conjure earth elemental reverse.", ch);
   break;
   }
   }

   CSPELL(cast_spell_control_weather)
   {
   switch (casttype) {
   case CAST_SPELL:
   spell_control_weather(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for control weather.", ch);
   break;
   }
   }

   CSPELL(cast_spell_creeping_doom)
   {
   switch (casttype) {
   case CAST_SPELL:
   spell_creeping_doom(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for creeping doom.", ch);
   break;
   }
   }

   CSPELL(cast_spell_destruction)
   {
   switch (casttype) {
   case CAST_SPELL:
   spell_destruction(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for destruction.", ch);
   break;
   }
   }

   CSPELL(cast_spell_earthquake)
   {
   switch (casttype) {
   case CAST_SPELL:
   spell_earthquake(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for earthquake.", ch);
   break;
   }
   }

   CSPELL(cast_spell_energy_drain)
   {
   switch (casttype) {
   case CAST_SPELL:
   spell_energy_drain(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for energy drain.", ch);
   break;
   }
   }

   CSPELL(cast_spell_exaction)
   {
   switch (casttype) {
   case CAST_SPELL:
   spell_exaction(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for exaction.", ch);
   break;
   }
   }

   CSPELL(cast_spell_fire_quench)
   {
   switch (casttype) {
   case CAST_SPELL:
   spell_fire_quench(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for fire quench.", ch);
   break;
   }
   }

   CSPELL(cast_spell_fire_storm)
   {
   switch (casttype) {
   case CAST_SPELL:
   spell_fire_storm(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for fire storm.", ch);
   break;
   }
   }

   CSPELL(cast_spell_gate)
   {
   switch (casttype) {
   case CAST_SPELL:
   spell_gate(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for gate.", ch);
   break;
   }
   }

   CSPELL(cast_spell_holy_word)
   {
   switch (casttype) {
   case CAST_SPELL:
   spell_holy_word(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for holy word.", ch);
   break;
   }
   }

   CSPELL(cast_spell_regenerate)
   {
   switch (casttype) {
   case CAST_SPELL:
   spell_regenerate(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for regenerate.", ch);
   break;
   }
   }

   CSPELL(cast_spell_reincarnate)
   {
   switch (casttype) {
   case CAST_SPELL:
   spell_reincarnate(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for reincarnate.", ch);
   break;
   }
   }

   CSPELL(cast_spell_restoration)
   {
   switch (casttype) {
   case CAST_SPELL:
   spell_restoration(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for restoration.", ch);
   break;
   }
   }

   CSPELL(cast_spell_resurrection)
   {
   switch (casttype) {
   case CAST_SPELL:
   spell_resurrection(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for resurrection.", ch);
   break;
   }
   }

   CSPELL(cast_spell_succor)
   {
   switch (casttype) {
   case CAST_SPELL:
   spell_succor(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for succor.", ch);
   break;
   }
   }

   CSPELL(cast_spell_succor_reverse)
   {
   switch (casttype) {
   case CAST_SPELL:
   spell_succor_reverse(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for succor reverse.", ch);
   break;
   }
   }

   CSPELL(cast_spell_sunray)
   {
   switch (casttype) {
   case CAST_SPELL:
   spell_sunray(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for sunray.", ch);
   break;
   }
   }

   CSPELL(cast_spell_symbol)
   {
   switch (casttype) {
   case CAST_SPELL:
   spell_symbol(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for symbol.", ch);
   break;
   }
   }

   CSPELL(cast_spell_transmute_metal_to_wood)
   {
   switch (casttype) {
   case CAST_SPELL:
   spell_transmute_metal_to_wood(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for transmute metal to wood.", ch);
   break;
   }
   }

   CSPELL(cast_spell_unholy_word)
   {
   switch (casttype) {
   case CAST_SPELL:
   spell_unholy_word(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for unholy word.", ch);
   break;
   }
   }

   CSPELL(cast_spell_wind_walk)
   {
   switch (casttype) {
   case CAST_SPELL:
   spell_wind_walk(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for wind walk.", ch);
   break;
   }
   }
 */
