/*****************************************************************/
/*                      World of GreyHawk                        */
/*      Begun in 1998, originally based on Circle3.0 and others  */
/* File:                                                         */
/* Purpose:                                                      */
/*****************************************************************/

/* Some smallmap stuff */
/* Map */
#define MAP_BLANK		0
#define MAP_WALL		1
#define MAP_CITY_STREET		2
#define MAP_NORMAL_FLOOR	3
#define MAP_CLOSED_DOOR		4
#define MAP_OPEN_DOOR		5
#define MAP_STAIR_DOWN          6
#define MAP_STAIR_UP		7
#define MAP_ME			8
#define MAP_PC			9
#define MAP_MOB			10
#define MAP_FIELD		11
#define MAP_TREE		12
#define MAP_HILL		13
#define MAP_SECRETDOOR		14
#define MAP_ROAD		15
#define MAP_BORDER		16
#define MAP_LAKE		17
#define MAP_MOUNTAIN            18
#define MAP_RUBBLE              19
#define MAP_BRUSH		20	/* passable tree */
#define MAP_FIELD2		21
#define MAP_CAVE		22
#define MAP_SWAMP		23
#define MAP_RIVER		24
#define MAP_NOTBLANK		25 /* I use this for fancy code shit */
#define MAP_FURN		26
#define MAP_FURN_THRONE		27
#define MAP_FURN_CHAIR		28
#define MAP_FURN_TABLE		29
#define MAP_FURN_BOOKCASE	30
#define MAP_FURN_BED		31
#define MAP_FURN_COUNTER	32
#define MAP_FURN_DESK		33
#define MAP_FURN_WELL		34
#define MAP_DESERT		35
#define MAP_CACTUS		36
#define MAP_TUNDRA		37
#define MAP_SNOWMOUNTAIN	38
#define MAP_STAIR_UPDOWN	39
#define MAP_TRAIL		40
#define MAP_PIT			41
#define MAP_WALL2		42
#define MAP_WALL3		43
#define MAP_WALL4		44
#define MAP_WALL5		45
#define MAP_WALL6		46
#define MAP_WOOD_FLOOR		47
#define MAP_SHIP_PART_GOOD	48
#define MAP_SHIP_PART_RUIN	49
#define MAP_LAVA		50
#define MAP_WALL7		51
#define MAP_WALL8		52
#define MAP_CHEST		53
#define MAP_SHIP1		54
#define MAP_BORDER2		55
#define MAP_OCCUPIED_DOOR	56
#define MAP_ROCK		57
#define MAP_BADLANDS		58
#define MAP_WOOD_ROOF		59

#define MAP_ERROR	 	60
#define NUM_MAP_SYMBOLS		MAP_ERROR + 1

#define IS_WALL(symbol) (symbol == MAP_WALL || symbol == MAP_WALL2 || \
		symbol == MAP_WALL3 || symbol == MAP_WALL4 || \
		symbol == MAP_WALL5 || symbol == MAP_WALL6 || \
		symbol == MAP_WALL7 || symbol == MAP_WALL8)

#define DRAW_WALL_ONLY(room, door) (IS_SET(VIRTUAL_EXIT(room, door)->exit_info, EX_WALLED))

/* Wall */
#define MAP2_CLOSED_DOOR	1
#define MAP2_OPEN_DOOR		2
#define MAP2_SECRETDOOR		3
#define MAP2_CONCEALDOOR	4
#define MAP2_OPEN_DOOR_NS	5
#define MAP2_OPEN_DOOR_EW	6
#define MAP2_CLOSE_DOOR_NS	7
#define MAP2_CLOSE_DOOR_EW	8
#define MAP2_OPEN_SECRET_NS	9
#define MAP2_OPEN_SECRET_EW	10
#define MAP2_CLOSE_SECRET_NS	11
#define MAP2_CLOSE_SECRET_EW	12
#define MAP2_OPEN_CONCEAL_NS	13
#define MAP2_OPEN_CONCEAL_EW	14
#define MAP2_CLOSE_CONCEAL_NS	15
#define MAP2_CLOSE_CONCEAL_EW	16

#define MAP2_WALL		30
#define MAP2_WALL1		31
#define MAP2_WALL2		32
#define MAP2_WALL3		33
#define MAP2_WALL4		34
#define MAP2_WALL5		35
#define MAP2_WALL6		36
#define MAP2_WALL7		37
#define MAP2_WALL8		38
#define MAP2_WALL9		39
#define MAP2_WALL10		40
#define MAP2_WALL11		41
#define MAP2_ROAD1		42
#define MAP2_ROAD2		43
#define MAP2_ROAD3		44
#define MAP2_ROAD4		45
#define MAP2_ROAD5		46
#define MAP2_ROAD6		47
#define MAP2_ROAD7		48
#define MAP2_ROAD8		49
#define MAP2_ROAD9		50
#define MAP2_ROAD10		51
#define MAP2_ROAD11		52
#define MAP2_RIVER1		53
#define MAP2_RIVER2		54
#define MAP2_RIVER3		55
#define MAP2_RIVER4		56
#define MAP2_RIVER5		57
#define MAP2_RIVER6		58
#define MAP2_RIVER7		59
#define MAP2_RIVER8		60
#define MAP2_RIVER9		61
#define MAP2_RIVER10		62
#define MAP2_RIVER11		63

/* Object */
#define MAP3_STAIR_DOWN     	1
#define MAP3_STAIR_UP		2
#define MAP3_ME			3
#define MAP3_PC			4
#define MAP3_MOB		5
#define MAP3_SHIP1		6
#define MAP3_SHIP2		7
#define MAP3_SHIP3		8
#define MAP3_SHIP4		9
#define MAP3_SHIP5		10
#define MAP3_FURNITURE		11

struct map_icon_info {
  char *icon;
  char *color;
  char *name;
};

#define CLIENT_MAP_PREFIX	"!!MAPPER"
#define CLIENT_SCORE_PREFIX	"!!SCORESHEET"
#define CLIENT_EQUIP_PREFIX	"!!EQUIPMENT"
#define CLIENT_SUFFIX		"!!MAINWINDOW"
