/* First Level Magic-User Spells */

/*****************************************************************/
/*                      World of GreyHawk                        */
/*      Begun in 1998, originally based on Circle3.0 and others  */
/* File:                                                         */
/* Purpose:                                                      */
/*****************************************************************/

#include "conf.h"
#include "sysdep.h"

#include "structs.h"

#include "utils.h"
#include "comm.h"
#include "spells.h"
#include "handler.h"
#include "db.h"

extern struct room_data *world;
extern struct obj_data *object_list;
extern struct char_data *character_list;
extern struct index_data *obj_index;

extern struct weather_data weather_info;
extern struct descriptor_data *descriptor_list;
extern struct zone_data *zone_table;

extern int mini_mud;

extern struct default_mobile_stats *mob_defaults;
extern char weapon_verbs[];
extern int *max_ac_applys;
extern struct apply_mod_defaults *apmd;

void clearMemory(struct char_data *ch);
void act(char *str, int i, struct char_data *c, struct obj_data *o,
	 void *vict_obj, int j);

void damage(struct char_data *ch, struct char_data *victim,
	    int damage, int weapontype, int which, int location);

void weight_change_object(struct obj_data *obj, int weight);
void add_follower(struct char_data *ch, struct char_data *leader);
int dice(int number, int size);
extern struct spell_info_type spell_info[];


struct char_data *read_mobile(int, int);

// First Level Magic-User Spells
/*
   CSPELL(cast_spell_affect_normal_fires)
   {
   switch (casttype) {
   case CAST_SPELL: 
   case CAST_SCROLL:
   spell_affect_normal_fires(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for affect normal fires.", ch);
   break;
   }
   }

   CSPELL(cast_spell_alarm)
   {
   switch (casttype) {
   case CAST_SPELL: 
   case CAST_SCROLL:
   spell_alarm(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for alarm.", ch);
   break;
   }
   }
 */
CSPELL(cast_spell_armor)
{
  switch (casttype) {
  case CAST_SPELL:
  case CAST_SCROLL:
    spell_armor(level, ch, victim, obj, loc, savetype, casttype);
    break;
  case CAST_POTION:
    spell_armor(level, ch, ch, obj, loc, savetype, casttype);
    break;
  default:
    send_to_char("Error, this is not a proper type for armor.", ch);
    break;
  }
}
/*
   CSPELL(cast_spell_audible_glamer)
   {
   switch (casttype) {
   case CAST_SPELL: 
   case CAST_SCROLL:
   spell_audible_glamer(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for audible glamer.", ch);
   break;
   }
   }
 */
CSPELL(cast_spell_burning_hands)
{
  switch (casttype) {
  case CAST_SPELL:
  case CAST_SCROLL:
    spell_burning_hands(level, ch, victim, obj, loc, savetype, casttype);
    break;
  default:
    send_to_char("Error, this is not a proper type for burning hands.", ch);
    break;
  }
}
/*
   CSPELL(cast_spell_cantrip)
   {
   switch (casttype) {
   case CAST_SPELL: 
   case CAST_SCROLL:
   spell_cantrip(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for cantrip.", ch);
   break;
   }
   }

   CSPELL(cast_spell_change_self)
   {
   switch (casttype) {
   case CAST_SPELL: 
   case CAST_SCROLL:
   spell_change_self(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for change self.", ch);
   break;
   }
   }
 */
CSPELL(cast_spell_charm_person)
{
  switch (casttype) {
  case CAST_SPELL:
  case CAST_SCROLL:
    spell_charm_person(level, ch, victim, obj, loc, savetype, casttype);
    break;
  default:
    send_to_char("Error, this is not a proper type for charm person.", ch);
    break;
  }
}
/*
   CSPELL(cast_spell_chill_touch)
   {
   switch (casttype) {
   case CAST_SPELL: 
   case CAST_SCROLL:
   spell_chill_touch(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for chill touch.", ch);
   break;
   }
   }

   CSPELL(cast_spell_color_spray)
   {
   switch (casttype) {
   case CAST_SPELL: 
   case CAST_SCROLL:
   spell_color_spray(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for color spray.", ch);
   break;
   }
   }

   CSPELL(cast_spell_comprehend_languages)
   {
   switch (casttype) {
   case CAST_SPELL: 
   case CAST_SCROLL:
   spell_comprehend_languages(level, ch, victim, obj, loc, savetype, casttype);
   break;
   case CAST_POTION:
   spell_comprehend_languages(level, ch, ch, obj, loc, savetype, casttype);
   default:
   send_to_char("Error, this is not a proper type for comprehend languages.", ch);
   break;
   }
   }

   CSPELL(cast_spell_confuse_languages)
   {
   switch (casttype) {
   case CAST_SPELL: 
   case CAST_SCROLL:
   spell_confuse_languages(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for confuse languages.", ch);
   break;
   }
   }

   CSPELL(cast_spell_dancing_lights)
   {
   switch (casttype) {
   case CAST_SPELL: 
   case CAST_SCROLL:
   spell_dancing_lights(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for dancing lights.", ch);
   break;
   }
   }
 */
CSPELL(cast_spell_detect_magic)
{
  switch (casttype) {
  case CAST_SPELL:
  case CAST_SCROLL:
    spell_detect_magic(level, ch, victim, obj, loc, savetype, casttype);
    break;
  case CAST_POTION:
    spell_detect_magic(level, ch, ch, obj, loc, savetype, casttype);
  default:
    send_to_char("Error, this is not a proper type for detect magic.", ch);
    break;
  }
}
/*
   CSPELL(cast_spell_detect_undead)
   {
   switch (casttype) {
   case CAST_SPELL: 
   case CAST_SCROLL:
   spell_detect_undead(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for detect undead.", ch);
   break;
   }
   }

   CSPELL(cast_spell_enlarge)
   {
   switch (casttype) {
   case CAST_SPELL: 
   case CAST_SCROLL:
   spell_enlarge(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for enlarge.", ch);
   break;
   }
   }

   CSPELL(cast_spell_erase)
   {
   switch (casttype) {
   case CAST_SPELL: 
   case CAST_SCROLL:
   spell_erase(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for erase.", ch);
   break;
   }
   }

   CSPELL(cast_spell_feather_fall)
   {
   switch (casttype) {
   case CAST_SPELL: 
   case CAST_SCROLL:
   spell_feather_fall(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for feather fall.", ch);
   break;
   }
   }

   CSPELL(cast_spell_find_familiar)
   {
   switch (casttype) {
   case CAST_SPELL: 
   case CAST_SCROLL:
   spell_find_familiar(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for find familiar.", ch);
   break;
   }
   }

   CSPELL(cast_spell_friends)
   {
   switch (casttype) {
   case CAST_SPELL: 
   case CAST_SCROLL:
   spell_friends(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for friends.", ch);
   break;
   }
   }
 */
CSPELL(cast_spell_gaze_reflection)
{
  switch (casttype) {
  case CAST_SPELL:
  case CAST_SCROLL:
    spell_gaze_reflection(level, ch, victim, obj, loc, savetype, casttype);
    break;
  case CAST_POTION:
    spell_gaze_reflection(level, ch, ch, obj, loc, savetype, casttype);
  default:
    send_to_char("Error, this is not the proper type for gaze reflection.", ch);
    break;
  }
}
/*
   CSPELL(cast_spell_grease)
   {
   switch (casttype) {
   case CAST_SPELL: 
   case CAST_SCROLL:
   spell_grease(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for grease.", ch);
   break;
   }
   }

   CSPELL(cast_spell_hold_portal)
   {
   switch (casttype) {
   case CAST_SPELL: 
   case CAST_SCROLL:
   spell_hold_portal(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for hold portal.", ch);
   break;
   }
   }

   CSPELL(cast_spell_hypnotism)
   {
   switch (casttype) {
   case CAST_SPELL: 
   case CAST_SCROLL:
   spell_hypnotism(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for hypnotism.", ch);
   break;
   }
   }

   CSPELL(cast_spell_identify)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_identify(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not the proper type for identify.", ch);
   break;
   }
   }

   CSPELL(cast_spell_jump)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_jump(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for jump.", ch);
   break;
   }
   }

   CSPELL(cast_spell_light)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_light(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for light.", ch);
   break;
   }
   }
 */
CSPELL(cast_spell_magic_missile)
{
  switch (casttype) {
  case CAST_SPELL:
  case CAST_SCROLL:
  case CAST_WAND:
  case CAST_STAFF:
    spell_magic_missile(level, ch, victim, obj, loc, savetype, casttype);
    break;
  default:
    send_to_char("Error, this is not a proper type for magic missile", ch);
    break;
  }
}
/*
   CSPELL(cast_spell_mending)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_mending(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for mending.", ch);
   break;
   }
   }

   CSPELL(cast_spell_message)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_message(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for message.", ch);
   break;
   }
   }

   CSPELL(cast_spell_mount)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_mount(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for mount.", ch);
   break;
   }
   }

   CSPELL(cast_spell_nystul_magical_aura)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_nystul_magical_aura(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for nystul's magical aura.", ch);
   break;
   }
   }

   CSPELL(cast_spell_phantasmal_force)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_phantasmal_force(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for phantasmal force.", ch);
   break;
   }
   }
 */
CSPELL(cast_spell_prot_from_evil)
{
  switch (casttype) {
  case CAST_SPELL:
  case CAST_SCROLL:
    spell_prot_from_evil(level, ch, victim, obj, loc, savetype, casttype);
    break;
  case CAST_POTION:
    spell_prot_from_evil(level, ch, ch, obj, loc, savetype, casttype);
    break;
  default:
    send_to_char("Error, this is not a proper type for protection from evil.", ch);
    break;
  }
}

CSPELL(cast_spell_prot_from_good)
{
  switch (casttype) {
  case CAST_SPELL:
  case CAST_SCROLL:
    spell_prot_from_good(level, ch, victim, obj, loc, savetype, casttype);
    break;
  case CAST_POTION:
    spell_prot_from_good(level, ch, ch, obj, loc, savetype, casttype);
    break;
  default:
    send_to_char("Error, this is not a proper type for protection from good.", ch);
    break;
  }
}
/*
   CSPELL(cast_spell_read_magic)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_read_magic(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for read magic.", ch);
   break;
   }
   }

   CSPELL(cast_spell_reduce)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_reduce(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for reduce.", ch);
   break;
   }
   }
 */
CSPELL(cast_spell_shield)
{
  switch (casttype) {
  case CAST_SPELL:
  case CAST_SCROLL:
    spell_shield(level, ch, victim, obj, loc, savetype, casttype);
    break;
  case CAST_POTION:
    spell_shield(level, ch, ch, obj, loc, savetype, casttype);
    break;
  default:
    send_to_char("Error, this is not a proper type for shield.", ch);
    break;
  }
}

CSPELL(cast_spell_shocking_grasp)
{
  switch (casttype) {
  case CAST_SPELL:
  case CAST_SCROLL:
    spell_shocking_grasp(level, ch, victim, obj, loc, savetype, casttype);
    break;
  default:
    send_to_char("Error, this is not a proper type for shocking grasp.", ch);
    break;
  }
}

CSPELL(cast_spell_sleep)
{
  switch (casttype) {
  case CAST_SPELL:
  case CAST_SCROLL:
  case CAST_WAND:
  case CAST_STAFF:
    spell_sleep(level, ch, victim, obj, loc, savetype, casttype);
    break;
  default:
    send_to_char("Error, this is not a proper type for sleep.", ch);
    break;
  }
}

CSPELL(cast_spell_stinking_cloud)
{
  switch (casttype) {
  case CAST_SPELL:
  case CAST_SCROLL:
  case CAST_WAND:
  case CAST_STAFF:
    spell_stinking_cloud(level, ch, victim, obj, loc, savetype, casttype);
    break;
  default:
    send_to_char("Error, this is not a proper type for stinking cloud.", ch);
    break;
  }
}
CSPELL(cast_spell_spider_climb)
{
  switch (casttype) {
  case CAST_SPELL:
  case CAST_SCROLL:
    spell_spider_climb(level, ch, victim, obj, loc, savetype, casttype);
    break;
  case CAST_POTION:
    spell_spider_climb(level, ch, ch, obj, loc, savetype, casttype);
    break;
  default:
    send_to_char("Error, this is not a proper type for shield.", ch);
    break;
  }
}
/*
   CSPELL(cast_spell_spook)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_spook(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for spook.", ch);
   break;
   }
   }

   CSPELL(cast_spell_taunt)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_taunt(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for taunt.", ch);
   break;
   }
   }

   CSPELL(cast_spell_tenser_floating_disc)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_tenser_floating_disc(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for tenser's floating disc.", ch);
   break;
   }
   }

   CSPELL(cast_spell_unseen_servant)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_unseen_servant(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for unseen servant.", ch);
   break;
   }
   }

   CSPELL(cast_spell_ventriloquism)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_ventriloquism(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for ventriloquism.", ch);
   break;
   }
   }

   CSPELL(cast_spell_wall_of_fog)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_wall_of_fog(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for wall of fog.", ch);
   break;
   }
   }

   CSPELL(cast_spell_wizard_mark)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_wizard_mark(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for wizard mark.", ch);
   break;
   }
   }
 */
/* Second Level Magic-User Spells */
/*
   CSPELL(cast_spell_alter_self)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_alter_self(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for alter self.", ch);
   break;
   }
   }

   CSPELL(cast_spell_bind)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_bind(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for bind.", ch);
   break;
   }
   }
 */
CSPELL(cast_spell_blindness)
{
  switch (casttype) {
  case CAST_SPELL:
  case CAST_SCROLL:
    spell_blindness(level, ch, victim, obj, loc, savetype, casttype);
    break;
  default:
    send_to_char("Error, this is not a proper type for blindness.", ch);
    break;
  }
}

CSPELL(cast_spell_blur)
{
  switch (casttype) {
  case CAST_SPELL:
  case CAST_SCROLL:
    spell_blur(level, ch, victim, obj, loc, savetype, casttype);
    break;
  default:
    send_to_char("Error, this is not a proper type for blur.", ch);
    break;
  }
}
/*
   CSPELL(cast_spell_continual_darkness)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_continual_darkness(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for continual darkness.", ch);
   break;
   }
   }

   CSPELL(cast_spell_continual_light)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_continual_light(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for continual light.", ch);
   break;
   }
   }

   CSPELL(cast_spell_darkness)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_darkness(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for darkness.", ch);
   break;
   }
   }

   CSPELL(cast_spell_deafness)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_deafness(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for deafness.", ch);
   break;
   }
   }

   CSPELL(cast_spell_deeppockets)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_deeppockets(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for deeppockets.", ch);
   break;
   }
   }
 */
CSPELL(cast_spell_detect_evil)
{
  switch (casttype) {
  case CAST_SPELL:
  case CAST_SCROLL:
    spell_detect_evil(level, ch, victim, obj, loc, savetype, casttype);
    break;
  default:
    send_to_char("Error, this is not a proper type for detect evil.", ch);
    break;
  }
}

CSPELL(cast_spell_detect_good)
{
  switch (casttype) {
  case CAST_SPELL:
  case CAST_SCROLL:
    spell_detect_good(level, ch, victim, obj, loc, savetype, casttype);
    break;
  default:
    send_to_char("Error, this is not a proper type for detect good.", ch);
    break;
  }
}

CSPELL(cast_spell_detect_invisibility)
{
  switch (casttype) {
  case CAST_SPELL:
  case CAST_SCROLL:
    spell_detect_invisibility(level, ch, victim, obj, loc, savetype, casttype);
    break;
  default:
    send_to_char("Error, this is not a proper type for detect invisibility.", ch);
    break;
  }
}
/*
   CSPELL(cast_spell_esp)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_esp(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for esp.", ch);
   break;
   }
   }

   CSPELL(cast_spell_flaming_sphere)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_flaming_sphere(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for flaming sphere.", ch);
   break;
   }
   }

   CSPELL(cast_spell_fog_cloud)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_fog_cloud(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for fog cloud.", ch);
   break;
   }
   }

   CSPELL(cast_spell_fools_gold)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_fools_gold(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for fool's gold.", ch);
   break;
   }
   }

   CSPELL(cast_spell_forget)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_forget(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for forget.", ch);
   break;
   }
   }

   CSPELL(cast_spell_glitterdust)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_glitterdust(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for glitterdust.", ch);
   break;
   }
   }

   CSPELL(cast_spell_hypnotic_pattern)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_hypnotic_pattern(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for hypnotic pattern.", ch);
   break;
   }
   }

   CSPELL(cast_spell_improved_phantasmal_force)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_improved_phantasmal_force(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for improved phantasmal force.", ch);
   break;
   }
   }
 */
CSPELL(cast_spell_invisibility)
{
  switch (casttype) {
  case CAST_SPELL:
  case CAST_SCROLL:
    spell_invisibility(level, ch, victim, obj, loc, savetype, casttype);
    break;
  default:
    send_to_char("Error, this is not a proper type for invisibility.", ch);
    break;
  }
}
/*
   CSPELL(cast_spell_irritation)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_irritation(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for irritation.", ch);
   break;
   }
   }

   CSPELL(cast_spell_knock)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_knock(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for knock.", ch);
   break;
   }
   }

   CSPELL(cast_spell_know_alignment)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_know_alignment(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for know alignment.", ch);
   break;
   }
   }

   CSPELL(cast_spell_leomund_trap)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_leomund_trap(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for leomund's trap.", ch);
   break;
   }
   }
 */
CSPELL(cast_spell_levitate)
{
  switch (casttype) {
  case CAST_SPELL:
  case CAST_SCROLL:
    spell_levitate(level, ch, victim, obj, loc, savetype, casttype);
    break;
  default:
    send_to_char("Error, this is not a proper type for levitate.", ch);
    break;
  }
}
/*
   CSPELL(spell_locate_object)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_locate_object(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for levitate.", ch);
   break;
   }
   }

   CSPELL(cast_spell_lock)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_lock(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for lock.", ch);
   break;
   }
   }

   CSPELL(cast_spell_magic_mouth)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_magic_mouth(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for magic mouth.", ch);
   break;
   }
   }

   CSPELL(cast_spell_melf_acid_arrow)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_melf_acid_arrow(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for melf's acid arrow.", ch);
   break;
   }
   }

   CSPELL(cast_spell_mirror_image)
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_mirror_image(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for levitate.", ch);
   break;
   }
   }

   CSPELL(cast_spell_misdirection)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_misdirection(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for misdirection.", ch);
   break;
   }
   }

   CSPELL(cast_spell_obscure_object)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_obscure_object(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for obscure object.", ch);
   break;
   }
   }

   CSPELL(cast_spell_protection_from_cantrips)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_protection_from_cantrips(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for protection from cantrips.", ch);
   break;
   }
   }

   CSPELL(cast_spell_pyrotechnics)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_pyrotechnics(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for pyrotechnics.", ch);
   break;
   }
   }
 */
CSPELL(cast_spell_ray_of_enfeeblement)
{
  switch (casttype) {
  case CAST_SPELL:
  case CAST_SCROLL:
    spell_ray_of_enfeeblement(level, ch, victim, obj, loc, savetype, casttype);
    break;
  default:
    send_to_char("Error, this is not a proper type for ray of enfeeblement.",
		 ch);
    break;
  }
}
/*
   CSPELL(cast_spell_rope_trick)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_rope_trick(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for rope trick.", ch);
   break;
   }
   }

   CSPELL(cast_spell_scare)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_scare(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for scare.", ch);
   break;
   }
   }

   CSPELL(cast_spell_shatter)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_shatter(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for shatter.", ch);
   break;
   }
   }

   CSPELL(cast_spell_spectral_hand)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_spectral_hand(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for spectral hand.", ch);
   break;
   }
   }

   CSPELL(cast_spell_stinking_cloud)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_stinking_cloud(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for stinking cloud.", ch);
   break;
   }
   }
 */
CSPELL(cast_spell_strength)
{
  switch (casttype) {
  case CAST_SPELL:
  case CAST_SCROLL:
    spell_strength(level, ch, victim, obj, loc, savetype, casttype);
    break;
  default:
    send_to_char("Error, this is not a proper type for strength.", ch);
    break;
  }
}
/*
   CSPELL(cast_spell_summon_swarm)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_summon_swarm(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for summon swarm.", ch);
   break;
   }
   }

   CSPELL(cast_spell_tasha_uncontrollable_hideous_laughter)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_tasha_uncontrollable_hideous_laughter(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for tasha's uncontrollable hideous laughter.", ch);
   break;
   }
   }

   CSPELL(cast_spell_undetectable_alignment)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_undetectable_alignment(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for undetectable alignment.", ch);
   break;
   }
   }

   CSPELL(cast_spell_web)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_web(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for web.", ch);
   break;
   }
   }

   CSPELL(cast_spell_whispering_wind)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_whispering_wind(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for whispering wind.", ch);
   break;
   }
   }

   CSPELL(cast_spell_wizard_lock)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_wizard_lock(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for wizard lock.", ch);
   break;
   }
   }
 */
/* Third Level Magic-User Spells */
/*
   CSPELL(cast_spell_air_breathing)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_air_breathing(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for air breathing.", ch);
   break;
   }
   }
 */
CSPELL(cast_spell_blink)
{
  switch (casttype) {
  case CAST_SPELL:
  case CAST_SCROLL:
    spell_blink(level, ch, victim, obj, loc, savetype, casttype);
    break;
  default:
    send_to_char("Error, this is not a proper type for blink.", ch);
    break;
  }
}
/*
   CSPELL(cast_spell_clairaudience)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_clairaudience(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for clairaudience.", ch);
   break;
   }
   }
 */
CSPELL(cast_spell_clairvoyance)
{
  switch (casttype) {
  case CAST_SPELL:
  case CAST_SCROLL:
    spell_clairvoyance(level, ch, victim, obj, loc, savetype, casttype);
    break;
  default:
    send_to_char("Error, this is not a proper type for clairvoyance.", ch);
    break;
  }
}
/*
   CSPELL(cast_spell_delude)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_delude(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for delude.", ch);
   break;
   }
   }

   CSPELL(cast_spell_dispel_magic)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_dispel_magic(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for dispel magic.", ch);
   break;
   }
   }

   CSPELL(cast_spell_explosive_runes)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_explosive_runes(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for explosive runes.", ch);
   break;
   }
   }

   CSPELL(cast_spell_feign_death)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_feign_death(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for feign death.", ch);
   break;
   }
   }
 */
CSPELL(cast_spell_fireball)
{
  switch (casttype) {
  case CAST_SPELL:
  case CAST_SCROLL:
    spell_fireball(level, ch, victim, obj, loc, savetype, casttype);
    break;
  default:
    send_to_char("Error, this is not a proper type for fireball.", ch);
    break;
  }
}
/*
   CSPELL(cast_spell_flame_arrow)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_flame_arrow(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for flame arrow.", ch);
   break;
   }
   }
 */
CSPELL(cast_spell_fly)
{
  switch (casttype) {
  case CAST_SPELL:
  case CAST_SCROLL:
    spell_fly(level, ch, victim, obj, loc, savetype, casttype);
    break;
  case CAST_POTION:
    spell_fly(level, ch, ch, obj, loc, savetype, casttype);
    break;
  default:
    send_to_char("Error, this is not a proper type for fly.", ch);
    break;
  }
}
/*
   CSPELL(cast_spell_gust_of_wind)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_gust_of_wind(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for gust of wind.", ch);
   break;
   }
   }
 */
CSPELL(cast_spell_haste)
{
  switch (casttype) {
  case CAST_SPELL:
  case CAST_SCROLL:
    spell_haste(level, ch, victim, obj, loc, savetype, casttype);
    break;
  default:
    send_to_char("Error, this is not a proper type for haste.", ch);
    break;
  }
}
/*
   CSPELL(cast_spell_hold_person)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_hold_person(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for hold person.", ch);
   break;
   }
   }

   CSPELL(cast_spell_hold_undead)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_hold_undead(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for hold undead.", ch);
   break;
   }
   }

   CSPELL(cast_spell_illusionary_script)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_illusionary_script(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for illusionary script.", ch);
   break;
   }
   }
 */
CSPELL(cast_spell_infravision)
{
  switch (casttype) {
  case CAST_SPELL:
  case CAST_SCROLL:
    spell_infravision(level, ch, victim, obj, loc, savetype, casttype);
    break;
  default:
    send_to_char("Error, this is not a proper type for infravision.", ch);
    break;
  }
}

CSPELL(cast_spell_invisibility_10)
{
  switch (casttype) {
  case CAST_SPELL:
  case CAST_SCROLL:
    spell_invisibility_10(level, ch, victim, obj, loc, savetype, casttype);
    break;
  default:
    send_to_char("Error, this is not a proper type for invisibility, 10' radius.", ch);
    break;
  }
}
/*
   CSPELL(cast_spell_item)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_item(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for item.", ch);
   break;
   }
   }

   CSPELL(cast_spell_leomund_tiny_hut)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_leomund_tiny_hut(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for leomund's tiny hut.", ch);
   break;
   }
   }

   CSPELL(cast_spell_lightning_bolt)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_lightning_bolt(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for lightning bolt.", ch);
   break;
   }
   }

   CSPELL(cast_spell_melf_minute_meteors)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_melf_minute_meteors(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for melf's minute meteors.", ch);
   break;
   }
   }

   CSPELL(cast_spell_monster_summoning_i)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_monster_summoning_i(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for monster summoning I.", ch);
   break;
   }
   }

   CSPELL(cast_spell_nondetection)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_nondetection(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for nondetection.", ch);
   break;
   }
   }

   CSPELL(cast_spell_phantom_steed)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_phantom_steed(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for phantom steed.", ch);
   break;
   }
   }

   CSPELL(cast_spell_prot_evil_10)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_prot_evil_10(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for protection from evil 10'.", ch);
   break;
   }
   }

   CSPELL(cast_spell_prot_good_10)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_prot_good_10(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for protection from good 10'.", ch);
   break;
   }
   }

   CSPELL(cast_spell_protection_from_normal_missiles)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_protection_from_normal_missiles(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for protection from normal missiles.", ch);
   break;
   }
   }

   CSPELL(cast_spell_secret_page)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_secret_page(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for secret page.", ch);
   break;
   }
   }

   CSPELL(cast_spell_sepia_snake_sigil)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_sepia_snake_sigil(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for sepia snake sigil.", ch);
   break;
   }
   }
 */
CSPELL(cast_spell_slow)
{
  switch (casttype) {
  case CAST_SPELL:
  case CAST_SCROLL:
    spell_slow(level, ch, victim, obj, loc, savetype, casttype);
    break;
  default:
    send_to_char("Error, this is not a proper type for slow.", ch);
    break;
  }
}
/*
   CSPELL(cast_spell_spectral_force)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_spectral_force(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for spectral force.", ch);
   break;
   }
   }

   CSPELL(cast_spell_suggestion)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_suggestion(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for suggestion.", ch);
   break;
   }
   }

   CSPELL(cast_spell_tongues)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_tongues(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for tongues.", ch);
   break;
   }
   }

   CSPELL(cast_spell_tongues_reverse)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_tongues_reverse(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for tongues reverse.", ch);
   break;
   }
   }

   CSPELL(cast_spell_vampiric_touch)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_vampiric_touch(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for vampiric touch.", ch);
   break;
   }
   }
 */
CSPELL(cast_spell_water_breathing)
{
  switch (casttype) {
  case CAST_SPELL:
  case CAST_SCROLL:
    spell_water_breathing(level, ch, victim, obj, loc, savetype, casttype);
    break;
  default:
    send_to_char("Error, this is not a proper type for water breathing.", ch);
    break;
  }
}
/*
   CSPELL(cast_spell_wind_wall)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_wind_wall(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for wind wall.", ch);
   break;
   }
   }
 */
CSPELL(cast_spell_wraithform)
{
  switch (casttype) {
  case CAST_SPELL:
  case CAST_SCROLL:
    spell_wraithform(level, ch, victim, obj, loc, savetype, casttype);
    break;
  default:
    send_to_char("Error, this is not a proper type for wraithform.", ch);
    break;
  }
}

/* Fourth Level Magic-User Spells */
/*
   CSPELL(cast_spell_bestow_curse)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_bestow_curse(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for bestow curse.", ch);
   break;
   }
   }

   CSPELL(cast_spell_charm_monster)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_charm_monster(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for charm monster.", ch);
   break;
   }
   }
 */
CSPELL(cast_spell_cold_shield)
{
  switch (casttype) {
  case CAST_SPELL:
  case CAST_SCROLL:
    spell_cold_shield(level, ch, victim, obj, loc, savetype, casttype);
    break;
  default:
    send_to_char("Error, this is not a proper type for cold shield.", ch);
    break;
  }
}
/*
   CSPELL(cast_spell_confusion)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_confusion(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for confusion.", ch);
   break;
   }
   }

   CSPELL(cast_spell_contagion)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_contagion(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for contagion.", ch);
   break;
   }
   }

   CSPELL(cast_spell_detect_scrying)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_detect_scrying(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for detect scrying.", ch);
   break;
   }
   }

   CSPELL(cast_spell_dig)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_dig(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for dig.", ch);
   break;
   }
   }

   CSPELL(cast_spell_dimension_door)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_dimension_door(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for dimension door.", ch);
   break;
   }
   }

   CSPELL(cast_spell_emotion)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_emotion(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for emotion.", ch);
   break;
   }
   }

   CSPELL (cast_spell_enchant_weapon)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_enchant_weapon(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for cold shield.", ch);
   break;
   }
   }

   CSPELL(cast_spell_enervation)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_enervation(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for enervation.", ch);
   break;
   }
   }

   CSPELL(cast_spell_evard_black_tentacles)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_evard_black_tentacles(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for evard's black tentacles.", ch);
   break;
   }
   }

   CSPELL(cast_spell_extension_i)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_extension_i(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for extension I.", ch);
   break;
   }
   }

   CSPELL(cast_spell_fear)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_fear(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for fear.", ch);
   break;
   }
   }

   CSPELL(cast_spell_fire_charm)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_fire_charm(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for fire charm.", ch);
   break;
   }
   }
 */
CSPELL(cast_spell_fire_shield)
{
  switch (casttype) {
  case CAST_SPELL:
  case CAST_SCROLL:
    spell_fire_shield(level, ch, victim, obj, loc, savetype, casttype);
    break;
  default:
    send_to_char("Error, this is not a proper type for fire shield.", ch);
    break;
  }
}
/*
   CSPELL(cast_spell_fire_trap)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_fire_trap(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for fire trap.", ch);
   break;
   }
   }

   CSPELL(cast_spell_fumble)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_fumble(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for fumble.", ch);
   break;
   }
   }

   CSPELL(cast_spell_hallucinatory_terrain)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_hallucinatory_terrain(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for hallucinatory terrain.", ch);
   break;
   }
   }

   CSPELL(cast_spell_ice_storm)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_ice_storm(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for ice storm.", ch);
   break;
   }
   }

   CSPELL(cast_spell_illusionary_wall)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_illusionary_wall(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for illusionary wall.", ch);
   break;
   }
   }

   CSPELL(cast_spell_improved_invisibility)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_improved_invisibility(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for improved invisibility.", ch);
   break;
   }
   }

   CSPELL(cast_spell_leomund_secure_shelter)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_leomund_secure_shelter(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for leomund's secure shelter.", ch);
   break;
   }
   }

   CSPELL(cast_spell_magic_mirror)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_magic_mirror(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for magic mirror.", ch);
   break;
   }
   }

   CSPELL(cast_spell_massmorph)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_massmorph(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for massmorph.", ch);
   break;
   }
   }

   CSPELL(cast_spell_minor_creation)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_minor_creation(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for minor creation.", ch);
   break;
   }
   }
 */
CSPELL(cast_spell_minor_globe_of_invulnerability)
{
  switch (casttype) {
  case CAST_SPELL:
  case CAST_SCROLL:
    spell_minor_globe_of_invulnerability(level, ch, victim, obj, loc, savetype, casttype);
    break;
  default:
    send_to_char("Error, this is not a proper type for minor globe of invulnerability.", ch);
    break;
  }
}
/*
   CSPELL(cast_spell_monster_summoning_ii)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_monster_summoning_ii(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for monster summoning II.", ch);
   break;
   }
   }

   CSPELL(cast_spell_otiluke_resilient_sphere)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_otiluke_resilient_sphere(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for otiluke's resilient sphere.", ch);
   break;
   }
   }

   CSPELL(cast_spell_phantasmal_killer)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_phantasmal_killer(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for phantasmal killer.", ch);
   break;
   }
   }

   CSPELL(cast_spell_plant_growth)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_plant_growth(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for plant growth.", ch);
   break;
   }
   }

   CSPELL(cast_spell_polymorph_other)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_polymorph_other(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for polymorph other.", ch);
   break;
   }
   }

   CSPELL(cast_spell_polymorph_self)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_polymorph_self(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for polymorph self.", ch);
   break;
   }
   }

   CSPELL(cast_spell_rainbow_pattern)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_rainbow_pattern(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for rainbow pattern.", ch);
   break;
   }
   }

   CSPELL(cast_spell_rary_mnemonic_enhancer)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_rary_mnemonic_enhancer(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for rary's mnemonic enhancer.", ch);
   break;
   }
   }

   CSPELL(cast_spell_remove_curse)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_remove_curse(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for remove curse.", ch);
   break;
   }
   }

   CSPELL(cast_spell_shadow_monsters)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_shadow_monsters(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for shadow monsters.", ch);
   break;
   }
   }

   CSPELL(cast_spell_shout)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_shout(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for shout.", ch);
   break;
   }
   }

   CSPELL(cast_spell_solid_fog)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_solid_fog(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for solid fog.", ch);
   break;
   }
   }

   CSPELL(cast_spell_stoneskin)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_stoneskin(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for stoneskin.", ch);
   break;
   }
   }

   CSPELL(cast_spell_vacancy)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_vacancy(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for vacancy.", ch);
   break;
   }
   }

   CSPELL(cast_spell_wall_of_fire)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_wall_of_fire(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for wall of fire.", ch);
   break;
   }
   }

   CSPELL(cast_spell_wall_of_ice)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_wall_of_ice(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for wall of ice.", ch);
   break;
   }
   }

   CSPELL(cast_spell_wizard_eye)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_wizard_eye(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for wizard eye.", ch);
   break;
   }
   }

 */
/* Fifth Level Magic-User Spells */
/*
   CSPELL(cast_spell_advanced_illusion)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_advanced_illusion(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for advanced illusion.", ch);
   break;
   }
   }

   CSPELL(cast_spell_airy_water)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_airy_water(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for airy water.", ch);
   break;
   }
   }

   CSPELL(cast_spell_animal_growth)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_animal_growth(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for animal growth.", ch);
   break;
   }
   }

   CSPELL(cast_spell_animate_dead)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_animate_dead(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for animate dead.", ch);
   break;
   }
   }

   CSPELL(cast_spell_attraction)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_attraction(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for attraction.", ch);
   break;
   }
   }

   CSPELL(cast_spell_avoidance)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_avoidance(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for avoidance.", ch);
   break;
   }
   }

   CSPELL(cast_spell_bigby_interposing_hand)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_bigby_interposing_hand(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for bigby's interposing hand.", ch);
   break;
   }
   }
   CSPELL(cast_spell_chaos)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_chaos(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for chaos.", ch);
   break;
   }
   }

   CSPELL(cast_spell_cloudkill)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_cloudkill(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for cloudkill.", ch);
   break;
   }
   }
 */
CSPELL(cast_spell_cone_of_cold)
{
  switch (casttype) {
  case CAST_SPELL:
  case CAST_SCROLL:
    spell_cone_of_cold(level, ch, victim, obj, loc, savetype, casttype);
    break;
  default:
    send_to_char("Error, this is not a proper type for cone of cold.", ch);
    break;
  }
}
/*
   CSPELL(cast_spell_conjure_elemental)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_conjure_elemental(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for conjure elemental.", ch);
   break;
   }
   }

   CSPELL(cast_spell_contact_other_plane)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_contact_other_plane(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for contact other plane.", ch);
   break;
   }
   }

   CSPELL(cast_spell_demishadow_monsters)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_demishadow_monsters(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for demishadow monsters.", ch);
   break;
   }
   }

   CSPELL(cast_spell_dismissal)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_dismissal(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for dismissal.", ch);
   break;
   }
   }

   CSPELL(cast_spell_distance_distortion)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_distance_distortion(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for distance distortion.", ch);
   break;
   }
   }

   CSPELL(cast_spell_domination)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_domination(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for domination.", ch);
   break;
   }
   }

   CSPELL(cast_spell_dream)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_dream(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for dream.", ch);
   break;
   }
   }

   CSPELL(cast_spell_extension_ii)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_extension_ii(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for extension II.", ch);
   break;
   }
   }

   CSPELL(cast_spell_fabricate)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_fabricate(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for fabricate.", ch);
   break;
   }
   }

   CSPELL(cast_spell_false_vision)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_false_vision(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for false vision.", ch);
   break;
   }
   }
 */
CSPELL(cast_spell_feeblemind)
{
  switch (casttype) {
  case CAST_SPELL:
  case CAST_SCROLL:
    spell_feeblemind(level, ch, victim, obj, loc, savetype, casttype);
    break;
  default:
    send_to_char("Error, this is not a proper type for feeblemind.", ch);
    break;
  }
}
/*
   CSPELL(cast_spell_hold_monster)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_hold_monster(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for hold monster.", ch);
   break;
   }
   }

   CSPELL(cast_spell_leomund_lamentable_belaborment)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_leomund_lamentable_belaborment(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for leomund's lamentable laborment.", ch);
   break;
   }
   }

   CSPELL(cast_spell_leomund_secret_chest)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_leomund_secret_chest(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for leomund's secret chest.", ch);
   break;
   }
   }

   CSPELL(cast_spell_magic_jar)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_magic_jar(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for magic jar.", ch);
   break;
   }
   }

   CSPELL(cast_spell_major_creation)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_major_creation(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for major creation.", ch);
   break;
   }
   }

   CSPELL(cast_spell_monster_summoning_iii)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_monster_summoning_iii(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for monster summoning III.", ch);
   break;
   }
   }

   CSPELL(cast_spell_mordenkainen_faithful_hound)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_mordenkainen_faithful_hound(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for mordenkainen's faithful hound.", ch);
   break;
   }
   }

   CSPELL(cast_spell_nightmare)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_nightmare(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for nightmare.", ch);
   break;
   }
   }

   CSPELL(cast_spell_passwall)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_passwall(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for passwall.", ch);
   break;
   }
   }

   CSPELL(cast_spell_seeming)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_seeming(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for seeming.", ch);
   break;
   }
   }

   CSPELL(cast_spell_sending)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_sending(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for sending.", ch);
   break;
   }
   }

   CSPELL(cast_spell_shadow_door)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_shadow_door(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for shadow door.", ch);
   break;
   }
   }

   CSPELL(cast_spell_shadow_magic)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_shadow_magic(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for shadow magic.", ch);
   break;
   }
   }

   CSPELL(cast_spell_shrink_animal)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_shrink_animal(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for shrink animal.", ch);
   break;
   }
   }

   CSPELL(cast_spell_stone_shape)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_stone_shape(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for stone shape.", ch);
   break;
   }
   }

   CSPELL(cast_spell_summon_shadow)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_summon_shadow(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for summon shadow.", ch);
   break;
   }
   }

   CSPELL(cast_spell_telekinesis)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_telekinesis(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for telekinesis.", ch);
   break;
   }
   }
 */
#if 0
CSPELL(cast_spell_teleport)
{
  switch (casttype) {
  case CAST_SPELL:
  case CAST_SCROLL:
    spell_teleport(level, ch, victim, obj, loc, savetype, casttype);
    break;
  default:
    send_to_char("Error, this is not a proper type for teleport.", ch);
    break;
  }
}
#endif
/*
   CSPELL(cast_spell_transmute_mud_to_rock)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_transmute_mud_to_rock(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for transmute mud to rock.", ch);
   break;
   }
   }

   CSPELL(cast_spell_transmute_rock_to_mud)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_transmute_rock_to_mud(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for transmute rock to mud.", ch);
   break;
   }
   }

   CSPELL(cast_spell_wall_of_force)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_wall_of_force(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for wall of force.", ch);
   break;
   }
   }

   CSPELL(cast_spell_wall of iron)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_wall_of_iron(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for wall of iron.", ch);
   break;
   }
   }

   CSPELL(cast_spell_wall_of_stone)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_wall_of_stone(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for wall of stone.", ch);
   break;
   }
   }
 */
/* Sixth Level Magic-User Spells */
/*
   CSPELL(cast_spell_antimagic_shell)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_antimagic_shell(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for antimagic shell.", ch);
   break;
   }
   }

   CSPELL(cast_spell_bigby_forceful_hand)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_bigby_forceful_hand(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for bigby forceful hand.", ch);
   break;
   }
   }

   CSPELL(cast_spell_chain_lightning)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_chain_lightning(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for chain lightning.", ch);
   break;
   }
   }

   CSPELL(cast_spell_conjure_animals)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_conjure_animals(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for conjure animals.", ch);
   break;
   }
   }

   CSPELL(cast_spell_contingency)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_contingency(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for contingency.", ch);
   break;
   }
   }

   CSPELL(cast_spell_control_weather)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_control_weather(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for control weather.", ch);
   break;
   }
   }

   CSPELL(cast_spell_death_fog)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_death_fog(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for death fog.", ch);
   break;
   }
   }

   CSPELL(cast_spell_death_spell)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_death_spell(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for death spell.", ch);
   break;ncy
   }
   }

   CSPELL(cast_spell_demishadow_magic)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_demishadow_magic(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for demishadow magic.", ch);
   break;
   }
   }

   CSPELL(cast_spell_disintegrate)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_disintegrate(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for disintegrate.", ch);
   break;
   }
   }

   CSPELL(cast_spell_enchant_an_item)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_enchant_an_item(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for enchant an item.", ch);
   break;
   }
   }

   CSPELL(cast_spell_ensnarement)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_ensnarement(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for ensnarement.", ch);
   break;
   }
   }

   CSPELL(cast_spell_extension_iii)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_extension_iii(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for extension III.", ch);
   break;
   }
   }

   CSPELL(cast_spell_eyebite)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_eyebite(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for eyebite.", ch);
   break;
   }
   }

   CSPELL(cast_spell_flesh_to_stone)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_flesh_to_stone(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for flesh to stone.", ch);
   break;
   }
   }

   CSPELL(cast_spell_geas)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_geas(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for geas.", ch);
   break;
   }
   }

   CSPELL(cast_spell_glassee)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_glassee(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for glassee.", ch);
   break;
   }
   }

   CSPELL(cast_spell_globe_of_invulnerability)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_globe_of_invulnerability(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for globe of invulnerability.", ch);
   break;
   }
   }

   CSPELL(cast_spell_guards_and_wards)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_guards_and_wards(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for guards and wards.", ch);
   break;
   }
   }

   CSPELL(cast_spell_invisible_stalker)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_invisible_stalker(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for invisible stalker.", ch);
   break;
   }
   }

   CSPELL(cast_spell_legend_lore)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_legend_lore(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for legend lore.", ch);
   break;
   }
   }

   CSPELL(cast_spell_lower_water)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_lower_water(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for lower water.", ch);
   break;
   }
   }

   CSPELL(cast_spell_mass_suggestion)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_mass_suggestion(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for mass suggestion.", ch);
   break;
   }
   }

   CSPELL(cast_spell_mirage_arcana)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_mirage_arcana(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for mirage arcana.", ch);
   break;
   }
   }

   CSPELL(cast_spell_mislead)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_mislead(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for mislead.", ch);
   break;
   }
   }

   CSPELL(cast_spell_monster_summoning_iv)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_monster_summoning_iv(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for monster summoning IV.", ch);
   break;
   }
   }

   CSPELL(cast_spell_mordenkainen_lucubration)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_mordenkainen_lucubration(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for mordenkainen's lucubration.", ch);
   break;
   }
   }

   CSPELL(cast_spell_move_earth)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_move_earth(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for move earth.", ch);
   break;
   }
   }

   CSPELL(cast_spell_otiluke_freezing_sphere)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_otiluke_freezing_sphere(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for otiluke's freezing sphere.", ch);
   break;
   }
   }

   CSPELL(cast_spell_part_water)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_part_water(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for part water.", ch);
   break;
   }
   }

   CSPELL(cast_spell_permanent_illusion)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_permanent_illusion(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for permanent illusion.", ch);
   break;
   }
   }

   CSPELL(cast_spell_programmed_illusion)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_programmed_illusion(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for programmed illusion.", ch);
   break;
   }
   }

   CSPELL(cast_spell_project_image)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_project_image(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for project image.", ch);
   break;
   }
   }

   CSPELL(cast_spell_raise_water)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_raise_water(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for raise water.", ch);
   break;
   }
   }

   CSPELL(cast_spell_reincarnation)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_reincarnation(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for reincarnation.", ch);
   break;
   }
   }

   CSPELL(cast_spell_repulsion)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_repulsion(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for repulsion.", ch);
   break;
   }
   }

   CSPELL(cast_spell_shades)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_shades(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for shades.", ch);
   break;
   }
   }

   CSPELL(cast_spell_stone_to_flesh)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_stone_to_flesh(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for stone to flesh.", ch);
   break;
   }
   }

   CSPELL(cast_spell_tenser_transformation)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_tenser_transformation(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for tenser transformation.", ch);
   break;
   }
   }

   CSPELL(cast_spell_transmute_dust_to_water)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_transmute_dust_to_water(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for transmute dust to water.", ch);
   break;
   }
   }

   CSPELL(cast_spell_transmute_water_to_dust)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_transmute_water_to_dust(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for transmute water to dust.", ch);
   break;
   }
   }

   CSPELL(cast_spell_true_seeing)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_true_seeing(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for true seeing.", ch);
   break;
   }
   }

   CSPELL(cast_spell_veil)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_veil(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for veil.", ch);
   break;
   }
   }
 */
/* Seventh Level Magic-User Spells */
/*
   CSPELL(cast_spell_banishment)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_banishment(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for banishment.", ch);
   break;
   }
   }

   CSPELL(cast_spell_bigby_grasping_hand)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_bigby_grasping_hand(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for bigby's grasping hand.", ch);
   break;
   }
   }

   CSPELL(cast_spell_charm_plant)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_charm_plant(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for charm plant.", ch);
   break;
   }
   }

   CSPELL(cast_spell_control_undead)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_control_undead(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for control undead.", ch);
   break;
   }
   }

   CSPELL(cast_spell_delayed_blast_fireball)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_delayed_blast_fireball(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for delayed blast fireball.", ch);
   break;
   }
   }

   CSPELL(cast_spell_drawmij_instant_summons)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_drawmij_instant_summons(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for drawmij's instant summons.", ch);
   break;
   }
   }

   CSPELL(cast_spell_duo_dimension)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_duo_dimension(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for duo-dimension.", ch);
   break;
   }
   }

   CSPELL(cast_spell_finger_of_death)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_finger_of_death(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for finger of death.", ch);
   break;
   }
   }

   CSPELL(cast_spell_forcecage)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_forcecage(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for forcecage.", ch);
   break;
   }
   }

   CSPELL(cast_spell_limited_wish)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_limited_wish(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for limited wish.", ch);
   break;
   }
   }

   CSPELL(cast_spell_mass_invisibility)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_mass_invisibility(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for mass invisibility.", ch);
   break;
   }
   }

   CSPELL(cast_spell_monster_summoning_v)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_monster_summoning_v(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for monster summoning v.", ch);
   break;
   }
   }

   CSPELL(cast_spell_mordenkainen_magnificent_mansion)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_mordenkainen_magnificent_mansion(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for mordenkainen's magnificent mansion.", ch);
   break;
   }
   }

   CSPELL(cast_spell_mordenkainen_sword)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_mordenkainen_sword(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for mordenkainen's sword.", ch);
   break;
   }
   }

   CSPELL(cast_spell_phase_door)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_phase_door(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for phase door.", ch);
   break;
   }
   }

   CSPELL(cast_spell_power_word_stun)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_vacancy(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for vacancy.", ch);
   break;
   }
   }

   CSPELL(cast_spell_power_word_stun)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_power_word_stun(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for power word stun.", ch);
   break;
   }
   }

   CSPELL(cast_spell_prismatic_spray)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_prismatic_spray(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for prismatic spray.", ch);
   break;
   }
   }

   CSPELL(cast_spell_reverse_gravity)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_reverse_gravity(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for reverse gravity.", ch);
   break;
   }
   }

   CSPELL(cast_spell_sequester)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_sequester(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for sequester.", ch);
   break;
   }
   }

   CSPELL(cast_spell_shadow_walk)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_shadow_walk(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for shadow walk.", ch);
   break;
   }
   }

   CSPELL(cast_spell_simulacrum)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_simulacrum(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for simulacrum.", ch);
   break;
   }
   }

   CSPELL(cast_spell_spell_turning)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_spell_turning(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for spell turning.", ch);
   break;
   }
   }

   CSPELL(cast_spell_statue)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_statue(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for statue.", ch);
   break;
   }
   }

   CSPELL(cast_spell_teleport_without_error)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_teleport_without_error(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for teleport without error.", ch);
   break;
   }
   }

   CSPELL(cast_spell_vanish)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_vanish(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for vanish.", ch);
   break;
   }
   }

   CSPELL(cast_spell_vision)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_vision(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for vision.", ch);
   break;
   }
   }
 */
/* Eighth Level Magic-User Spells */
/*
   CSPELL(cast_spell_antipathy_sympathy)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_antipathy_sympathy(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for antipathy-sympathy.", ch);
   break;
   }
   }

   CSPELL(cast_spell_bigby_clenched_fist)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_bigby_clenched_fist(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for bigby's clenched fist.", ch);
   break;
   }
   }

   CSPELL(cast_spell_binding)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_binding(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for binding.", ch);
   break;
   }
   }

   CSPELL(cast_spell_clone)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_clone(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for clone.", ch);
   break;
   }
   }

   CSPELL(cast_spell_demand)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_demand(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for demand.", ch);
   break;
   }
   }

   CSPELL(cast_spell_glassteel)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_glassteel(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for glassteel.", ch);
   break;
   }
   }

   CSPELL(cast_spell_incendiary_cloud)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_incendiary_cloud(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for incendiary cloud.", ch);
   break;
   }
   }

   CSPELL(cast_spell_mass_charm)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_mass_charm(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for mass charm.", ch);
   break;
   }
   }

   CSPELL(cast_spell_maze)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_maze(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for maze.", ch);
   break;
   }
   }

   CSPELL(cast_spell_mind_blank)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_mind_blank(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for mind blank.", ch);
   break;
   }
   }

   CSPELL(cast_spell_monster_summoning_vi)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_monster_summoning_vi(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for monster summoning VI.", ch);
   break;
   }
   }

   CSPELL(cast_spell_otiluke_telekinetic_sphere)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_otiluke_telekinetic_sphere(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for otiluke's telekinetic sphere.", ch);
   break;
   }
   }

   CSPELL(cast_spell_otto_irresistible_dance)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_otto_irresistible_dance(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for otto's irresistible dance.", ch);
   break;
   }
   }

   CSPELL(cast_spell_permanency)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_permanency(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for permanency.", ch);
   break;
   }
   }

   CSPELL(cast_spell_polymorph_any_object)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_polymorph_any_object(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for polymorph any object.", ch);
   break;
   }
   }
 */
CSPELL(cast_spell_power_word_blind)
{
  switch (casttype) {
  case CAST_SPELL:
  case CAST_SCROLL:
    spell_power_word_blind(level, ch, victim, obj, loc, savetype, casttype);
    break;
  default:
    send_to_char("Error, this is not a proper type for power word blind.",
		 ch);
    break;
  }
}
/*
   CSPELL(cast_spell_prismatic_wall)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_prismatic_wall(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for prismatic wall.", ch);
   break;
   }
   }

   CSPELL(cast_spell_screen)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_screen(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for screen.", ch);
   break;
   }
   }

   CSPELL(cast_spell_serten_spell_immunity)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_serten_spell_immunity(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for serten's spell immunity.", ch);
   break;
   }
   }

   CSPELL(cast_spell_sink)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_sink(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for sink.", ch);
   break;
   }
   }

   CSPELL(cast_spell_symbol)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_symbol(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for symbol.", ch);
   break;
   }
   }

   CSPELL(cast_spell_trap_the_soul)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_trap_the_soul(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for trap the soul.", ch);
   break;
   }
   }
 */
/* Ninth Level Magic-User Spells */
/*
   CSPELL(cast_spell_astral_spell)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_astral_spell(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for astral spell.", ch);
   break;
   }
   }

   CSPELL(cast_spell_bigby_crushing_hand)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_bigby_crushing_hand(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for bigby's crushing hand.", ch);
   break;
   }
   }

   CSPELL(cast_spell_crystalbrittle)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_crystalbrittle(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for crystalbrittle.", ch);
   break;
   }
   }

   CSPELL(cast_spell_energy_drain)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_energy_drain(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for energy drain.", ch);
   break;
   }
   }

   CSPELL(cast_spell_foresight)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_foresight(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for foresight.", ch);
   break;
   }
   }

   CSPELL(cast_spell_freedom)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_freedom(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for freedom.", ch);
   break;
   }
   }

   CSPELL(cast_spell_gate)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_gate(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for gate.", ch);
   break;
   }
   }

   CSPELL(cast_spell_imprisonment)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_imprisonment(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for imprisonment.", ch);
   break;
   }
   }

   CSPELL(cast_spell_meteor_swarm)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_meteor_swarm(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for meteor swarm.", ch);
   break;
   }
   }

   CSPELL(cast_spell_monster_summoning_vii)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_monster_summoning_vii(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for monster summoning VII.", ch);
   break;
   }
   }

   CSPELL(cast_spell_mordenkainen_disjunction)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_mordenkainen_disjunction(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for mordenkainen's disjunction.", ch);
   break;
   }
   }
 */
CSPELL(cast_spell_power_word_kill)
{
  switch (casttype) {
  case CAST_SPELL:
  case CAST_SCROLL:
    spell_power_word_kill(level, ch, victim, obj, loc, savetype, casttype);
    break;
  default:
    send_to_char("Error, this is not a proper type for power word kill.", ch);
    break;
  }
}
/*
   CSPELL(cast_spell_prismatic_sphere)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_prismatic_sphere(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for prismatic sphere.", ch);
   break;
   }
   }

   CSPELL(cast_spell_shape_change)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_shape_change(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for shape change.", ch);
   break;
   }
   }

   CSPELL(cast_spell_succor)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_succor(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for succor.", ch);
   break;
   }
   }

   CSPELL(cast_spell_succor_reverse)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_succor_reverse(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for succor reverse.", ch);
   break;
   }
   }

   CSPELL(cast_spell_temporal_reinstatement)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_temporal_reinstatement(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for temporal reinstatement.", ch);
   break;
   }
   }

   CSPELL(cast_spell_temporal_stasis)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_temporal_stasis(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for temporal stasis.", ch);
   break;
   }
   }

   CSPELL(cast_spell_time_stop)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_time_stop(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for time stop.", ch);
   break;
   }
   }

   CSPELL(cast_spell_weird)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_weird(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for weird.", ch);
   break;
   }
   }

   CSPELL(cast_spell_wish)
   {
   switch (casttype) {
   case CAST_SPELL: case CAST_SCROLL:
   spell_wish(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for wish.", ch);
   break;
   }
   }
 */
