
/*****************************************************************/
/*                      World of GreyHawk                        */
/*      Begun in 1998, originally based on Circle3.0 and others  */
/* File:                                                         */
/* Purpose:                                                      */
/*****************************************************************/

#define FIRST_SKILL                  1

#define SKILL_BACKSTAB               1
#define SKILL_HIDE                   2
#define SKILL_PICK_LOCK              3
#define SKILL_SNEAK                  4
#define SKILL_STEAL                  5
#define SKILL_LISTEN                 6
#define SKILL_FIND_TRAP              7
#define SKILL_CLIMB_WALL             8
#define SKILL_READ_LANGUAGE          9

/* to be remove */
#define SKILL_BASH                   10
#define SKILL_KICK                   11
#define SKILL_PUNCH                  12
#define SKILL_RESCUE                 13
#define SKILL_TRACK		     14
#define SKILL_MOUNT		     15
#define SKILL_RIDING		     16
#define SKILL_TAME		     17

/* styles */
#define SKILL_STYLE_WEAPON_SHIELD	20
#define SKILL_STYLE_ONE_HANDED_WEAPON	21
#define SKILL_STYLE_TWO_HANDED_WEAPON	22
#define SKILL_STYLE_TWO_WEAPON		23
#define SKILL_STYLE_MISSILE		24

/* weapon proficiency */
#define SKILL_BATTLE_AXE		25
#define SKILL_BOW			26
#define SKILL_CLUB			27
#define SKILL_CROSSBOW			28
#define SKILL_DAGGER			29
#define SKILL_DART			30
#define SKILL_FLAIL			31
#define SKILL_MACE			32
#define SKILL_PICK			33
#define SKILL_HAMMER			34
#define SKILL_HAND_AXE			35
#define SKILL_HARPOON			36
#define SKILL_JAVELIN			37
#define SKILL_KNIFE			38
#define SKILL_LANCE			39
#define SKILL_MANCATCHER		40
#define SKILL_MORNING_STAR		41
#define SKILL_POLEARM			42
#define SKILL_STAFF			43
#define SKILL_SCROUGE			44
#define SKILL_SICKLE			45
#define SKILL_SLING			46
#define SKILL_SPEAR			47
#define SKILL_STAFF_SLING		48
#define SKILL_BASTARD_SWORD		49
#define SKILL_BROAD_SWORD		50
#define SKILL_KHOPESH			51
#define SKILL_LONG_SWORD		52
#define SKILL_SHORT_SWORD		53
#define SKILL_TWO_HANDED_SWORD		54
#define SKILL_TRIDENT			55
#define SKILL_WHIP			56
#define SKILL_SCIMITAR			57
#define SKILL_SHIELD			58
#define SKILL_RAPIER			59
#define SKILL_SABER			60

/* non-weapon proficiency */
#define SKILL_ANIMAL_HANDLING		100
#define SKILL_ANIMAL_TRAINING		101
#define SKILL_BLACKSMITHING		102
#define SKILL_COOKING			103
#define SKILL_FISHING			104
#define SKILL_LEATHER_WORKING		105
#define SKILL_RIDING_LAND		106
#define SKILL_RIDING_AIRBORN		107
#define SKILL_ROPE_USE			108
#define SKILL_SEAMANSHIP		109
#define SKILL_TAILOR			110
#define SKILL_SWIMMING			111
#define SKILL_HEALING			112
#define SKILL_HERBALISM			113
#define SKILL_MUSICAL_INSTRUMENT	114
#define SKILL_NAVIGATION		115
#define SKILL_READING_WRITING		116
#define SKILL_RELIGION			117
#define SKILL_SPELLCRAFT		118
#define SKILL_APPRAISING		119
#define SKILL_BLIND_FIGHTING		120
#define SKILL_DISGUISE			121
#define SKILL_FORGERY			122
#define SKILL_GAMING			123
#define SKILL_GEM_CUTTING		124
#define SKILL_JUMPING			125
#define SKILL_READING_LIPS		126
#define SKILL_SET_SNARES		127
#define SKILL_ARMORER			128
#define SKILL_BOWYER			129
#define SKILL_ENDURANCE			130
#define SKILL_HUNTING			131
#define SKILL_MOUNTAINEERING		132
#define SKILL_RUNNING			133
#define SKILL_SURVIVAL			134
#define SKILL_TRACKING			135
#define SKILL_WEAPONSMITHING		136
#define SKILL_LANGUAGE			137

#define LAST_SKILL                   137

#define TOTAL_SKILLS                 (LAST_SKILL + 1)

/* Skill stat */
#define SKILL_STAT_NONE 0
#define SKILL_STAT_STR  1
#define SKILL_STAT_DEX  2
#define SKILL_STAT_CON  3
#define SKILL_STAT_INT  4
#define SKILL_STAT_WIS  5
#define SKILL_STAT_CHA  6

#define SKILL_CLASS_CLERIC      BIT_1
#define SKILL_CLASS_DRUID	BIT_2
#define SKILL_CLASS_FIGHTER     BIT_3
#define SKILL_CLASS_PALADIN	BIT_4
#define SKILL_CLASS_RANGER	BIT_5
#define SKILL_CLASS_MAGIC_USER  BIT_6
#define SKILL_CLASS_ILLUSIONIST BIT_7
#define SKILL_CLASS_THIEF	BIT_8
#define SKILL_CLASS_BARD	BIT_9
#define SKILL_CLASS_MULTI_C_M   BIT_10
#define SKILL_CLASS_MULTI_F_M   BIT_11
#define SKILL_CLASS_MULTI_F_T   BIT_12
#define SKILL_CLASS_MULTI_M_T   BIT_13
#define SKILL_CLASS_MULTI_F_M_T BIT_14
#define SKILL_CLASS_MULTI_C_R   BIT_15
#define SKILL_CLASS_MULTI_C_F   BIT_16
#define SKILL_CLASS_MULTI_I_T   BIT_17
#define SKILL_CLASS_MULTI_C_F_M BIT_18
#define SKILL_CLASS_MULTI_C_T   BIT_19
#define SKILL_CLASS_MULTI_F_I   BIT_20
#define SKILL_CLASS_MULTI_C_I   BIT_21

#define SKILL_CLASS_ALL         BIT_22


#define SKILL_TYPE_NOT_DEFINED 0
#define SKILL_TYPE_NON_WEAPON  1
#define SKILL_TYPE_WEAPON      2
#define SKILL_TYPE_MISC        3
#define SKILL_TYPE_THIEF       4
#define SKILL_TYPE_FIGHTER		 5

struct skill_info_type {
  const char *name;
  byte can_use[NUM_CLASSES];
  byte type;
  byte num_slot_req;
  byte stat_use;
  byte check_mod;
};


/* other prototypes */
void init_skills(struct char_data *ch);
void mag_assign_skills(void);
void improve_skill(struct char_data *ch, int Skill);
